//  SPINkDIB g͉ss // 폜ĉB
//{$DEFINE USESPINkDIB}

unit d6main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
{$IFDEF USESPINkDIB}
  SPINkDIB, NkDIB,
{$ENDIF}
  StdCtrls, ExtDlgs, ExtCtrls, SPIs, ComCtrls;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    Button1: TButton;
    Image1: TImage;
    ProgressBar1: TProgressBar;
    Button2: TButton;
    SPIs1: TSPIs;
    Button3: TButton;
    ListView1: TListView;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    procedure Button1Click(Sender: TObject);
    procedure SPIs1Search(Sender: TObject; ASPI: TSPI;
      var Accept: Boolean);
    procedure SPIs1PictureRegister(Sender: TObject; ASPI: TInSPI;
      const AExtension, ADescription: String;
      var AGraphicClass: TGraphicClass);
    procedure Image1Progress(Sender: TObject; Stage: TProgressStage;
      PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
      const Msg: String);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SPIs1Searching(Sender: TObject; FileName: String;
      var Accept: Boolean);
  private
    FLoadAbort: Boolean;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  executed: Boolean;
begin
  with OpenPictureDialog1 do begin
    Filter := GraphicFilter(TGraphic);

    //  vOC̃vr[@\g
    //  vOCvr[@\Ă΃_CAO\łꂪg
    //  C\摜TCY͏Ȃ
    SPIs1.GraphicPreview := True;
    try
      executed := Execute;
    finally
      //  {Ԃł͌ʂ̃TCYœǍ̂ŁC
      //  Ńvr[@\؂Ă
      SPIs1.GraphicPreview := False;
    end;

    if executed then begin
      Image1.Picture.LoadFromFile(FileName);
      SavePictureDialog1.FileName := ChangeFileExt(FileName, '.bmp');
    end;
  end;
end;

procedure TForm1.SPIs1Search(Sender: TObject; ASPI: TSPI;
  var Accept: Boolean);
begin
  //  ͗p Plugin ݂̂g
  Accept := ASPI is TInSPI;
end;

procedure TForm1.SPIs1PictureRegister(Sender: TObject; ASPI: TInSPI;
  const AExtension, ADescription: String;
  var AGraphicClass: TGraphicClass);
begin
  {$IFDEF USESPINkDIB}
  AGraphicClass := TSPINkDIB;
  {$ENDIF}

  //  JPEG`SPIł͂ȂATJPEGImage gĎ́Auses  JPEG 
  //  ǉāAL̂悤ɂĂB
  //if (UpperCase(AExtension) = 'JPG') or
  //	 (UpperCase(AExtension) = 'JPEG') then begin
  //  AGraphicClass := nil;
  //end;

  //  gq '*.*' ԂvOCւ̑Ή鎞̏
  //  '*.*' ԂvOĆAPicutreRegister Ȃꍇ̗
  //  邱ƂŁAGraphicFilter(TGraphic) ̖ߒl '*.*' ܂܂
  //  ȂȂAOpenDialog ȂǂŃtH_[̑S̃t@C\
  //  邱ƂȂȂB
  //if AExtension = '*' then begin
  //  AGraphicClass := nil;
	//end;
end;

procedure TForm1.Image1Progress(Sender: TObject; Stage: TProgressStage;
  PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
  const Msg: String);
begin
  if Stage = psStarting then begin
    FLoadAbort := False;
    Button1.Enabled := False;
    Button2.Enabled := False;
    Button3.Enabled := True;
  end
  else if Stage = psEnding then begin
    Button1.Enabled := True;
    Button2.Enabled := True;
    Button3.Enabled := False;
  end;

	ProgressBar1.Position := PercentDone;

  Application.ProcessMessages;

  if FLoadAbort then begin
    Abort;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
	spiIdx: Integer;
  clmIdx: Integer;
  newItem: TListItem;
begin
  with ListView1.Columns do begin
    for clmIdx := 0 to Count-1 do begin
      Items[clmIdx].Width := Self.Width div Count;
    end;
  end;

	with ListView1.Items do begin
  	BeginUpdate;
    try
    	Clear;

			for spiIdx := 0 to SPIs1.Count-1 do begin
        newItem := Add;

				with SPIs1.Plugins[spiIdx] do begin
          newItem.Caption := FileName;
          newItem.SubItems.Add(Infomation);
          newItem.SubItems.Add(ExtNames[0]);
          newItem.SubItems.Add(FileTypes[0]);
        end;
      end;
    finally
    	EndUpdate;
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if (Image1.Picture.Graphic <> nil) and
     ((Image1.Picture.Graphic is TBitmap)
{$IFDEF USESPINkDIB}
     or (Image1.Picture.Graphic is TNkDIB)
{$ENDIF}
     ) then begin
    with SavePictureDialog1 do begin
      Filter := GraphicFilter(TBitmap);
      if Execute then begin
        Image1.Picture.SaveToFile(FileName);
      end;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  FLoadAbort := True;
end;

procedure TForm1.SPIs1Searching(Sender: TObject; FileName: String;
  var Accept: Boolean);
begin
{
  //  ̖ÕvOCǂݍ܂Ȃ
  //  ̗łٍ͐ ifcamf.spi ǂݍ܂Ȃ悤ɂĂ
  //  łAȂƂȂŁAifcamf.spi Ă^^;;
  if CompareText(ExtractFileName(FileName), 'ifcamf.spi') = 0 then begin
    Accept := False;
  end;
}
end;

end.
