//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package( smart_init )

#if( __BORLANDC__ < 0x0550 )

namespace Archives {
	struct TIndivisualInfo;
	class DELPHICLASS TArchiverOptions;

#if( __BORLANDC__ <= 0x0530 )	//	C++ Builder 3 ȑOH
	typedef INT     TDELPHIHANDLE;
	typedef INT     TDELPHIDWORD;
	typedef PINT    PDELPHIDWORD;
#else
	typedef UINT    TDELPHIHANDLE;
	typedef UINT    TDELPHIDWORD;
	typedef PUINT   PDELPHIDWORD;
#endif

class PASCALIMPLEMENTATION TArchiveFile : public Classes::TComponent {
public:
	int  __fastcall UnpackFiles  ( TDELPHIHANDLE Handle,TArchiverOptions* Options,System::AnsiString DstPath,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall PackFiles    ( TDELPHIHANDLE Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall RemoveItems  ( TDELPHIHANDLE Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall UpdateArchive( TDELPHIHANDLE Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall MakeSfx      ( TDELPHIHANDLE Handle,TArchiverOptions* Options,System::AnsiString DstPath );
	int  __fastcall UnpackToMem  ( TDELPHIHANDLE Handle,TArchiverOptions* Options,System::AnsiString FileName,void* lpvBuffer,TDELPHIDWORD dwSize,PDELPHIDWORD lpdwWriteSize );
	void __fastcall FindOpen     ( TDELPHIHANDLE Handle,TDELPHIDWORD dwMode );

	int  __fastcall UnpackFiles  ( HWND Handle,TArchiverOptions* Options,System::AnsiString DstPath,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall PackFiles    ( HWND Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall RemoveItems  ( HWND Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall UpdateArchive( HWND Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize );
	int  __fastcall MakeSfx      ( HWND Handle,TArchiverOptions* Options,System::AnsiString DstPath );
	int  __fastcall UnpackToMem  ( HWND Handle,TArchiverOptions* Options,System::AnsiString FileName,void* lpvBuffer,TDELPHIDWORD dwSize,PDWORD lpdwWriteSize );
	void __fastcall FindOpen     ( HWND Handle,TDELPHIDWORD dwMode );
};

int __fastcall TArchiveFile::PackFiles( HWND Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize ){
	return PackFiles( TDELPHIHANDLE( Handle ),Options,BaseDir,FileList,FileListSize );
}

int __fastcall TArchiveFile::UnpackFiles( HWND Handle,TArchiverOptions* Options,System::AnsiString DstPath,const System::TVarRec* FileList,const int FileListSize ){
	return UnpackFiles( TDELPHIHANDLE( Handle ),Options,DstPath,FileList,FileListSize );
}

int __fastcall TArchiveFile::RemoveItems( HWND Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize ){
	return RemoveItems( TDELPHIHANDLE( Handle ),Options,BaseDir,FileList,FileListSize );
}

int __fastcall TArchiveFile::UpdateArchive( HWND Handle,TArchiverOptions* Options,System::AnsiString BaseDir,const System::TVarRec* FileList,const int FileListSize ){
	return UpdateArchive( TDELPHIHANDLE( Handle ),Options,BaseDir,FileList,FileListSize );
}

int __fastcall TArchiveFile::MakeSfx( HWND Handle,TArchiverOptions* Options,System::AnsiString DstPath ){
	return MakeSfx( TDELPHIHANDLE( Handle ),Options,DstPath );
}

int __fastcall TArchiveFile::UnpackToMem( HWND Handle,TArchiverOptions* Options,System::AnsiString FileName,void* lpvBuffer,TDELPHIDWORD dwSize,PDWORD lpdwWriteSize ){
	return UnpackToMem( TDELPHIHANDLE( Handle ),Options,FileName,lpvBuffer,TDELPHIDWORD( dwSize ),PDELPHIDWORD( lpdwWriteSize ));
}

void __fastcall TArchiveFile::FindOpen( HWND Handle,TDELPHIDWORD dwMode ){
	TArchiveFile::FindOpen( TDELPHIHANDLE( Handle ),dwMode );
}

};

#endif	//	__BORLANDC__ < 0x0550
