unit HTTPSub;

(* PersonalłɂHTTPEncodeȂ *)
(* Copyright (c) 2001,2002 hetareprog@hotmail.com *)


interface

uses
  SysUtils;

function URLEncode(const str: string): string;
function URLEncode2(const str: string): string;

implementation

{$B-} (* short circuit *)

function URLEncode(const str: string): string;
var
  s: string;
  i: integer;
begin
  s := '';
  for i := 1 to length(str) do
  begin
    case str[i] of
    '0'..'9','A'..'Z','a'..'z', '_':
      s := s + str[i];
    else
      s := s + Format('%%%2.2X', [Ord(str[i])]);
    end;
  end;
  result := s;
end;

function URLEncode2(const str: string): string;
var
  s: string;
  i: integer;
  isAnk: boolean;
begin
  isAnk := true;
  s := '';
  for i := 1 to length(str) do
  begin
    if str[i] >= #$80 then
    begin
      isAnk := false;
    end;
    s := s + Format('%%%2.2x', [Ord(str[i])]);
  end;
  if isAnk then
  begin
    result := str;
  end
  else
  begin
    result := AnsiLowerCase(s);
  end;
end;

end.
