unit UWriteForm;
(* ݉ *)
(* Copyright (c) 2001,2002 Twiddle <hetareprog@hotmail.com> *)

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  ComCtrls,
  StdCtrls,
  DateUtils,
  ActnList,
  Menus,
  {$IFDEF IE}
  OleCtrls,
  SHDocVw_TLB,
  MSHTML_TLB,
  {$ELSE}
  HogeTextView,
  UTVSub,
  {$ENDIF}
  StrUtils,
  IniFiles,
  U2chThread,
  U2chBoard,
  HTTPSub,
  IdBaseComponent,
  IdComponent,
  IdTCPConnection,
  IdTCPClient,
  IdHTTP,
  IdURI,
  JConfig,
  UDat2HTML,
  UViewItem,
  UAsync,
  UXTime,
  U2chTicket,
  ULocalCopy,
  StrSub,
  UCrypt,
  jconvert;

type
  TPostType = (postNormal, postCheck);
  TFormType = (formWrite, formBuild);

  TWriteForm = class(TForm)
    PageControl: TPageControl;
    TabSheetMain: TTabSheet;
    Panel1: TPanel;
    TabSheetLocalRule: TTabSheet;
    EditNameBox: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    EditMailBox: TComboBox;
    CheckBoxSage: TCheckBox;
    Memo: TMemo;
    Panel2: TPanel;
    Panel3: TPanel;
    ButtonWrite: TButton;
    ButtonCancel: TButton;
    TabSheetResult: TTabSheet;
    Result: TMemo;
    ThreadTitlePanel: TPanel;
    RecordCheckBox: TCheckBox;
    CheckBoxTop: TCheckBox;
    EditSubjectBox: TEdit;
    TitleLabel: TLabel;
    SubjectPanel: TPanel;
    Panel4: TPanel;
    TabSheetPreview: TTabSheet;
    ActionList: TActionList;
    writeActWrite: TAction;
    writeActCancel: TAction;
    writeActFocusThread: TAction;
    AAList: TListBox;
    writeActShowAAList: TAction;
    TabSheetSettingTxt: TTabSheet;
    SettingTxt: TMemo;
    WStatusBar: TStatusBar;
    EditLineNumber: TEdit;
    WaitTimer: TTimer;  //beginner
    ComboBoxProxyForWriting: TComboBox;
    CheckBoxUseProxyForWriting: TCheckBox;
    ButtonOpen: TButton; //rika

    procedure PageControlChange(Sender: TObject);
    procedure CheckBoxSageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonWriteClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function Hook(var Message: TMessage): Boolean;
    procedure MemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RecordCheckBoxClick(Sender: TObject); //521
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBoxTopClick(Sender: TObject);
    procedure writeActFocusThreadExecute(Sender: TObject);
    procedure AAListMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure writeActShowAAListExecute(Sender: TObject);
    procedure AAListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AAListExit(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure WStatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure WaitTimerTimer(Sender: TObject);  //beginner
    procedure CheckBoxUseProxyForWritingClick(Sender: TObject); //rika
    procedure ComboBoxProxyForWritingChange(Sender: TObject);
    //procedure ListBoxOneLineAAExit(Sender: TObject);
    //procedure ListBoxOneLineAAKeyDown(Sender: TObject; var Key: Word;
    //  Shift: TShiftState);
    //procedure ListBoxOneLineAAMouseUp(Sender: TObject;
    //  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    //procedure ButtonAAClick(Sender: TObject);
    procedure ButtonOpenClick(Sender: TObject);
  private
    { Private 錾 }
    savedTop : integer;
    savedLeft : integer;
    savedWidth: integer;
    savedHeight: integer;
    gotRule: TProgState;
    procGet: TAsyncReq;
    procPost: TAsyncReq;
    storedRule: TLocalCopy;
    writeRetryCount: Integer;
    cookieRetryCount: Integer;
    postType: TPostType;
    postCode: string;
    kakikomiFile: TFileStream;
    formType: TFormType;
    FtimeValue: Int64;
    LoadText: TStringList;
    {$IFDEF IE}
    WebBrowser: TWebBrowser;
    Preview: TWebBrowser;
    {$ELSE}
    TextView: THogeTextView;
    Preview: THogeTextView;
    PreviewStatus:string; //beginner
    {$ENDIF}
    {beginner}
    HideOnApplicationMinimize: Boolean;
    gotSettingTxt: TProgState;
    storedSettingTxt: TLocalCopy;
    procGetSettingTxt: TAsyncReq;
    BBSLineNumuber: Integer;
    BBSMessageCount: Integer;
    PanelColor: array[0..2] of TColor;  //pl̐m
    WaitCount: Cardinal;
    RecentHost: String;
    WaitList: TStringList;
    Writing: Boolean;
    TimeForWait: Cardinal;
    procedure GetSettingTxt;
    procedure OnSettingTxt(sender: TAsyncReq);
    {/beginner}
    procedure PostArticle;
    procedure GetLocalRule;
    procedure OnNotify(sender: TAsyncReq; code: TAsyncNotifyCode);
    procedure OnWritten(sender: TAsyncReq);
    procedure OnLocalRule(sender: TAsyncReq);
    procedure WritePreview;
    procedure MakePreview;
    procedure OnAsyncDoneProc2(sender: TAsyncReq);
    {$IFDEF IE}
    procedure WebBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure WebBrowserBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure PreviewBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure PreviewBrowserBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure WebBrowserStatusTextChange(Sender: TObject;
                                              const Text: WideString);
    {$ELSE}
    procedure OnBrowserMouseMove(Sender: TObject; Shift: TShiftState;
                                 X, Y: Integer);
    procedure OnBrowserMouseDown(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    {$ENDIF}
    procedure BrowserStatusTextChange(Sender:TObject; AStatusText:string);
    procedure BeforeNavigate(const URL: String; var Cancel: WordBool);
    procedure RequestToGetLocalRule;
    procedure PasteAAListItem;
    procedure SetNameBox(NameCombo: TCombobox; NameList: TStringList; const Board: string);  //beginner(by nono)

  protected
    //procedure ON_WM_ACTIVATE (var msg: TWMActivate); message WM_ACTIVATE; //rika
    //procedure ON_WM_NCLBUTTONDOWN(var Msg: TMsg); message WM_NCLBUTTONDOWN;
    procedure CreateParams(var Params: TCreateParams); override;
    function Res2Dat: string;

  public
    { Public 錾 }
    freeReserve: boolean;  //ݒύXfp̉\
    thread: TThreadItem;
    board: TBoard;
    chotto: boolean;
    procedure Show(threadItem: TThreadItem); overload;
    procedure Show(boardItem: TBoard); overload;
    procedure Show(dmy: string); overload; //rika
    class function Trip(const Key: string): string;
    function SavedBoundsRect:TRect; //beginner
    procedure MainWndOnHide; //beginner
    procedure MainWndOnShow; //beginner
  end;

var
  WriteForm: TWriteForm;

(*=======================================================*)
implementation
(*=======================================================*)

uses
  Main, IdCookie;

const
  WAIT_LIST_FILE = 'WriteWait.ini';

{$R *.dfm}

(* [J[ASETTING.TXT擾Avr[LbN *)
procedure TWriteForm.PageControlChange(Sender: TObject);
var
  ActiveTab: TTabSheet;
begin
  (*  *)
  ActiveTab := PageControl.Pages[PageControl.ActivePageIndex];

  if ActiveTab = TabSheetLocalRule then
    GetLocalRule
  else if ActiveTab = TabSheetSettingTxt then
    GetSettingTxt
  else if ActiveTab = TabSheetPreview then
    MakePreview;
end;

(* ^XNo[ *)
procedure TWriteForm.CreateParams(var Params: TCreateParams);
begin
  inherited;
  if FormStyle in [fsNormal, fsStayOnTop] then
    if BorderStyle in [bsSingle, bsSizeable] then
      if Config.wrtFmUseTaskBar then
      begin
        Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
        Params.WndParent := 0;
      end else
        Params.ExStyle := Params.ExStyle and (not WS_EX_APPWINDOW);
end;

(* ̏ *)
procedure TWriteForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caFree;
 WriteForm := nil;
end;

(* őOʂ *)
procedure TWriteForm.CheckBoxTopClick(Sender: TObject);
begin
  if Visible then //\̂CreateEShowȊO͂ňʒuETCYۑ
    SavedBoundsRect;
  Config.wrtFormStayOnTop := CheckBoxTop.Checked;
  if Config.wrtFmUseTaskBar then
  begin
    SetWindowLong(self.Handle, GWL_HWNDPARENT, 0);
    if CheckBoxTop.Checked then
      FormStyle := fsStayOnTop
    else
      FormStyle := fsNormal;
  end
  else begin
    SetWindowLong(self.Handle, GWL_HWNDPARENT, MainWnd.Handle);
    FormStyle := fsNormal;
  end  
end;

(* SAGE *)
procedure TWriteForm.CheckBoxSageClick(Sender: TObject);
begin
  if CheckBoxSage.Checked then
  begin
    EditMailBox.Text := 'sage';
    EditMailBox.Enabled := false;
  end
  else begin
    EditMailBox.Text := '';
    EditMailBox.Enabled := true;
  end;
end;

(* OE[L`FbN *)//521
procedure TWriteForm.RecordCheckBoxClick(Sender: TObject);
begin
  Config.wrtRecordNameMail := RecordCheckBox.checked;
end;

(*  *)
procedure TWriteForm.FormCreate(Sender: TObject);

  procedure KeyConf;
  var
    ini: TMemIniFile;
    i: integer;

    procedure SetShortCut(action: TAction);
    var
      key: string;
    begin
      key := ini.ReadString('KEY', action.Name, '');
      if key = '' then
        exit;
      action.ShortCut := TextToShortCut(key);
      if (action.ShortCut = 0) and (length(key) > 1)then
      try
        action.ShortCut := StrToInt(key);
      except
      end;
    end;
  begin
    if not FileExists(Config.BasePath + KEYCONF_FILE) then
      exit;
    ini := TMemIniFile.Create(Config.BasePath + KEYCONF_FILE);
    for i := 0 to ActionList.ActionCount -1 do
      SetShortCut(TAction(ActionList.Actions[i]));
    ini.Free;
  end;

  procedure LoadAAlist;
  var
    index: integer;
  begin
    index := 0;
    LoadText := TStringList.Create;
    if  (FileExists(IncludeTrailingPathDelimiter(Config.BasePath) + AALIST_FILE))  then
      LoadText.LoadFromFile(IncludeTrailingPathDelimiter(Config.BasePath) + AALIST_FILE);
    if LoadText.count <= 0 then
      exit;
    while (CompareStr('[aalist]', LoadText[index]) <> 0) do
    begin
      Inc(index);
      if LoadText.Count - 1 <= index then
        exit;
    end;
    Inc(index);
    while not(StartWith('[', LoadText[index], 1)) do
    begin
      AAList.Items.Add(LoadText[index]);
      if index < LoadText.Count - 1 then
        Inc(index)
      else
        break;
    end;
  end;  
var
  font: TFont;
begin
  savedLeft := 0;
  savedTop  := 0;
  savedWidth := 0;
  savedHeight := 0;
  writeRetryCount := 0;
  cookieRetryCount := 0;
  postType := postNormal;
  postCode := '';
  board := nil;
  thread := nil;
  chotto := false;
  procGet := nil;
  procPost := nil;
  FormStyle := fsNormal; // http://pc2.2ch.net/test/read.cgi/win/1045044108/223
  {$IFDEF IE}
  WebBrowser := TWebBrowser.Create(TabSheetLocalRule);
  TOleControl(WebBrowser).Parent := TabSheetLocalRule;
  with WebBrowser do
  begin
    Align := alClient;
    OnBeforeNavigate2  := WebBrowserBeforeNavigate2;
    OnDocumentComplete := WebBrowserDocumentComplete;
  end;
  Preview := TWebBrowser.Create(TabSheetPreview);
  TOleControl(Preview).Parent := TabSheetPreview;
  Preview.Align := alClient;
  Preview.OnDocumentComplete := PreviewBrowserDocumentComplete;
  Preview.OnBeforeNavigate2 := PreviewBrowserBeforeNavigate2;
  Preview.OnStatusTextChange := WebBrowserStatusTextChange;
  {$ELSE}
  TextView := THogeTextView.Create(TabSheetLocalRule);
  with TextView do
  begin
    Parent := TabSheetLocalRule;
    Align := alClient;
    Enabled := True;
    Visible := True;
    TabStop := True;
    LeftMargin := 8;
    TopMargin := 4;
    RightMargin := 8;
    ExternalLeading := 1;
    VerticalCaretMargin := 1;
    VScrollLines := 5;
    TextAttrib[1].style := [fsBold];
    TextAttrib[2].color := clBlue;
    TextAttrib[2].style := [fsUnderline];
    TextAttrib[3].color := clBlue;
    TextAttrib[3].style := [fsBold, fsUnderline];
    TextAttrib[4].color := clRed;
    TextAttrib[5].color := clGreen;
    OnMouseMove := OnBrowserMouseMove;
    OnMouseDown := OnBrowserMouseDown;
  end;
  Preview := THogeTextView.Create(TabSheetPreview);
  with Preview do
  begin
    Parent := TabSheetPreview;
    Align := alClient;
    LeftMargin := 8;
    TopMargin := 4;
    RightMargin := 8;
    ExternalLeading := 1;
    VerticalCaretMargin := Config.viewVerticalCaretMargin;
    WheelPageScroll := Config.viewPageScroll;
    VScrollLines := Config.viewScrollLines;
    {beginner}
    EnableAutoScroll := Config.viewEnableAutoScroll;
    Frames := Config.viewScrollSmoothness;
    FrameRate := Config.viewScrollFrameRate;
    {/beginner}
    Font.Name := 'lr oSVbN';
    Color := RGB($ef, $ef, $ef);
    TextAttrib[1].style := [fsBold];
    TextAttrib[2].color := clBlue;
    TextAttrib[2].style := [fsUnderline];
    TextAttrib[3].color := clBlue;
    TextAttrib[3].style := [fsBold, fsUnderline];
    TextAttrib[4].color := clGreen;
    TextAttrib[5].color := clGreen;
    TextAttrib[5].style := [fsBold];
    OnMouseMove := OnBrowserMouseMove;
  end;
  {$ENDIF}
  if Config.viewDefFontInfo.face <> '' then
  begin
    font := TFont.Create;
    Config.SetFont(font, Config.viewDefFontInfo);
    Self.Font.Assign(font);
    font.Free;
  end;
  if Config.viewWriteFontInfo.face <> '' then
  begin
    font := TFont.Create;
    Config.SetFont(font, Config.viewWriteFontInfo);
    Memo.Font.Assign(font);
    font.Free;
  end;

  //[457]
  ThreadTitlePanel.Color := MainWnd.ThreadToolPanel.Color;
  ThreadTitlePanel.Font := MainWnd.ThreadTitleLabel.Font;

  storedRule := nil;
  storedSettingTxt := nil;
  //CEBhẼV[gJbg𖳌
  Application.HookMainWindow(hook);
  KeyConf;
  CheckBoxTop.Enabled := Config.wrtFmUseTaskBar;

  EditNameBox.Items := Config.wrtNameList;
  EditMailBox.Items := Config.wrtMailList;

  LoadAAlist;
  HideOnApplicationMinimize:=False; //beginner

  freeReserve := false;

  WaitList := TStringList.Create;
  try
    WaitList.LoadFromFile(ExtractFilePath(Application.ExeName) + WAIT_LIST_FILE);
  except
    WaitList.Clear;
  end;

end;

(* []\ *)
procedure TWriteForm.FormActivate(Sender: TObject);
begin
  if WindowState<>wsMaximized then begin
    if 0 < savedWidth then
      Width := savedWidth;
    if 0 < savedHeight then
      Height := savedHeight;
  end;

  //XEBhEANeBuIMEL
  SetImeMode(Handle, userImeMode);
end;

(* זɂȂȂ悤ɂ *)
procedure TWriteForm.FormDeactivate(Sender: TObject);
begin
  if WindowState<>wsMinimized then begin
    savedLeft := Left;
    savedTop  := Top;
    savedWidth:= Width;
    savedHeight:= Height;
    if not Config.wrtFmUseTaskBar then
      Height := 10;
  end;

  //XEBhEtH[JXOƂIMEԂۑ
  SaveImeMode(Handle);
end;

{procedure TWriteForm.ON_WM_ACTIVATE (var msg: TWMActivate); //rika
begin
  if not Config.wrtFmUseTaskBar then
    if msg.Active = WA_INACTIVE then
    begin
      SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or
                   SWP_NOSIZE or SWP_NOACTIVATE);
    end
    else begin
      if (ActiveControl = nil) and not (csDesigning in ComponentState) then
        ActiveControl := FindNextControl(nil, True, True, False);
      SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or
                  SWP_NOSIZE or SWP_NOACTIVATE);
    end;
end;}

(* ݎIMEɉ̑΍  Ȃꂵ *)
{procedure TWriteForm.ON_WM_NCLBUTTONDOWN(var Msg: TMsg);
begin
  if not Config.wrtFmUseTaskBar and
     (userImeMode <> imClose) and   //IMEI[v(ɂȂ\)
     //ANeBuANeBuɂȂMemoɃtH[JXڂƂ
     not Self.Active and (ActiveControl = Memo) and not Memo.Focused and
     (Self.WindowState <> wsMinimized) then
    Memo.SetFocus //WM_NCLBUTTONDOWNȂ
  else
    inherited;
end;}

(* \ *)
procedure TWriteForm.Show(threadItem: TThreadItem);
begin
  if assigned(thread) then
  begin
    SetFocus;
  end
  else begin
    thread := threadItem;
    thread.AddRef;
  end;
  formType := formWrite;
  board := TBoard(thread.board);

  //XpEBhE̕\Ԑݒ
  Self.Caption := 'w' + thread.title + 'x ɃX';
  ThreadTitlePanel.Visible := Config.wrtShowThreadTitle;
  Panel1.Visible := true; //184
  SubjectPanel.Visible := false;
  ThreadTitlePanel.Caption := 'y' + StringReplace(thread.GetBoardName + 'z - ' + HTML2String(thread.title), '&', '&&', [rfReplaceAll]);
  RecordCheckBox.Enabled :=true;
  PageControl.ActivePage := TabSheetMain;

  //Oƃ[
  //521 LName/Mail{bNX
  RecordCheckBox.checked := Config.wrtRecordNameMail;
  CheckBoxSage.Checked := false;
  //O
  SetNameBox(self.EditNameBox, Config.wrtNameList, board.bbs);
  if thread.UsedWriteMail <> '' then
    EditNameBox.Text := thread.UsedWriteName
  else if (thread.UsedWriteMail = '') and // LĂȂX(LꂽXɂ͕K!)
          Config.wrtUseDefaultName and (Config.wrtNameList.Count > 0) then
    EditNameBox.Text := EditNameBox.Items[0]
  else
    EditNameBox.Text := '';
  //[
  if thread.UsedWriteMail <> '' then
    EditMailBox.Text := thread.UsedWriteMail
  else if (thread.UsedWriteMail = '') and Config.wrtDefaultSageCheck then
    EditMailBox.Text := 'sage'
  else
    EditMailBox.Text := '';
  if AnsiStartsStr('!',EditMailBox.Text) then
    EditMailBox.Text := Copy(EditMailBox.Text, 2, length(EditMailBox.Text) - 1);

  CheckBoxTop.Checked := Config.wrtFormStayOnTop;
  if Config.wrtFmUseTaskBar and not CheckBoxTop.Checked then
    FormStyle := fsNormal;

  inherited Show;
end;

(* XĎ̕\ *)
procedure TWriteForm.Show(boardItem: TBoard);
begin
  if assigned(board) then
  begin
    SetFocus;
  end
  else begin
    board := boardItem;
  end;
  formType := formBuild;
  thread := nil;

  //XėpEBhE̕\Ԑݒ
  Self.Caption := 'y' + board.name + 'z ɐVKXbh';
  SubjectPanel.Visible := true;
  ThreadTitlePanel.Visible := false;
  Panel1.Visible := true; //184
  EditSubjectBox.Text := '';
  RecordCheckBox.Enabled :=false;
  PageControl.ActivePage := TabSheetLocalRule;

  //Oƃ[
  if (Config.wrtUseDefaultName) and (Config.wrtNameList.Count <>0) then
    EditNameBox.Text := EditNameBox.Items[0]
  else
    EditNameBox.Text := '';
  if Config.wrtDefaultSageCheck then
    EditMailBox.Text := 'sage'
  else
    EditMailBox.Text := '';

  CheckBoxTop.Checked := Config.wrtFormStayOnTop;
  if Config.wrtFmUseTaskBar and not CheckBoxTop.Checked then
    FormStyle := fsNormal;

  inherited Show;
end;

procedure TWriteForm.SetNameBox(NameCombo: TCombobox; NameList: TStringList; const Board: string);
var
  i: Integer;
  tkBoard, tkName: string;
begin
  NameCombo.Items.Clear;
  for i := 0 to NameList.Count - 1 do
  begin
    if (NameList[i] <> '') and (NameList[i][1] = '<') and (AnsiPos('>', NameList[i]) <> 0) then
    begin
      tkBoard := Copy(NameList[i], 2, AnsiPos('>', NameList[i]) - 2);
      tkName := Copy(NameList[i], AnsiPos('>', NameList[i]) + 1, Length(NameList[i]) - AnsiPos('>', NameList[i]));
    end else
    begin
      tkBoard := '*';
      tkName := NameList[i];
    end;

    if (tkBoard = Board) or (tkBoard = '*') then
      if NameCombo.Items.IndexOf(tkName) < 0 then
        NameCombo.Items.Add(tkName);
  end;
end;

(* ƌ鎞̕\ *)
procedure TWriteForm.Show(dmy: string);
begin
  if chotto then
  begin
    SetFocus;
  end
  else begin
    chotto := true;
  end;
  formType := formBuild;

  //ƌpEBhE̕\Ԑݒ
  Self.Caption := 'ƌr[[';
  Panel1.Visible := false; //184
  ThreadTitlePanel.Visible := false;
  SubjectPanel.Visible := false;
  {$IFNDEF IE}
  TextView.Color := RGB($ef, $ef, $ef);
  {$ENDIF}
  ButtonOpen.Visible := true;
  Panel2.Visible := false;
  CheckBoxTop.Visible := false;
  RecordCheckBox.Visible := false;
//  TabSheet1.TabVisible := false;
  TabSheetPreview.TabVisible := false;
  TabSheetLocalRule.Caption := MainWnd.chottoURL;

  PageControl.ActivePageIndex := 2;

  CheckBoxTop.Checked := Config.wrtFormStayOnTop;
  if Config.wrtFmUseTaskBar and not CheckBoxTop.Checked then
    FormStyle := fsNormal;

  inherited Show;
end;

(* \ *)
procedure TWriteForm.FormShow(Sender: TObject);
var
  NeedSETTINGTXT: Boolean; 
  iniProxy:TMemIniFile; //rikaproxy
  //iniAA:TMemIniFile; //rikaAA
begin
  if not HideOnApplicationMinimize then
  begin
    //XEXċ
    if EditMailBox.Text = 'sage' then
    begin
      EditMailBox.Enabled := false;
      CheckBoxSage.Checked := true;
    end
    else begin
      EditMailBox.Enabled := true;
      CheckBoxSage.Checked := false;
    end;
    if not chotto then begin //184 ɂƌ̃G[
    {beginner}
    Writing := False;
    if (board.host <> RecentHost) or not WaitTimer.Enabled then begin
      ButtonWrite.Enabled := true;
      ButtonWrite.Caption := '(&W)';
    end else begin
      ButtonWrite.Enabled := false;
    end;
    {/beginner}
    end;
    TabSheetResult.TabVisible := (procPost <> nil);
    gotRule := tpsNone;
    gotSettingTxt := tpsNone;
    postType := postNormal;
    postCode := '';

    if Config.wrtDisableStatusBar then
      WStatusBar.Hide
    else
      WStatusBar.Show;

    {beginner} //ۑꂽʒuATCYɈړ
    if (Config.wrtFormTop >= 0) and (Config.wrtFormLeft >= 0) and
       (Config.wrtFormHeight >= 0) and (Config.wrtFormWidth >= 0) then
      BoundsRect := Bounds(Config.wrtFormLeft, Config.wrtFormTop,
                    Config.wrtFormWidth, Config.wrtFormHeight);
    {/beginner}

  //
  //rikaproxy C_Jane2chProxy_txt̓eR{{bNX̃XgɃZbg
  if FileExists(IncludeTrailingPathDelimiter(Config.BasePath) + 'Proxy.txt') then
  begin
    iniProxy := TMemIniFile.Create(IncludeTrailingPathDelimiter(Config.BasePath) + 'Proxy.txt');
    try
      iniProxy.ReadSectionValues('Write',ComboBoxProxyForWriting.Items);
    finally
      FreeAndNil(iniProxy);
    end;//try
  end;

  //rikaproxy Config̒l̏ݗpProxyZbgB
  if Config.netProxyServerForWriting <> '' then begin
    ComboBoxProxyForWriting.Text := Config.netProxyServerForWriting + ':' + IntTostr(Config.netProxyPortForWriting);
    ComboBoxProxyForWriting.Items.Insert(0,ComboBoxProxyForWriting.Text); //Xg̐擪ɓo^
  end;

  //rikaproxy Proxygp̗LRg[ɔf
  CheckBoxUseProxyForWriting.Checked := config.netUseProxy;
  CheckBoxUseProxyForWritingClick(CheckBoxUseProxyForWriting);
  //܂

  //rikaAA C_Jane2chaalist_txt̓eR{{bNX̃XgɃZbg
  {if FileExists(IncludeTrailingPathDelimiter(Config.BasePath) + 'aalist.txt') then
  begin
    iniAA := TMemIniFile.Create(IncludeTrailingPathDelimiter(Config.BasePath) + 'aalist.txt');
    try
      iniAA.ReadSectionValues('aalist',ListBoxOneLineAA.Items);
    finally
      FreeAndNil(iniAA);
    end;//try
  end;}

    //[JS]
    if EditNameBox.CanFocus then
      EditNameBox.SetFocus;
    if Memo.CanFocus then
      Memo.SetFocus;
    if PageControl.ActivePage = TabSheetLocalRule then
      GetLocalRule;

    CheckBoxTopClick(Sender);
    
    //SETTING.TXT
    FreeAndNil(storedSettingTxt);
    NeedSETTINGTXT := False;
    BBSLineNumuber := 0;
    BBSMessageCount := 0;
    SettingTxt.Clear;
    try
      storedSettingTxt := TLocalCopy.Create(board.GetLogDir + '\setting.txt', '.idb');
      if storedSettingTxt.Load then
      begin
        SettingTxt.Text := storedSettingTxt.DataString;
        BBSLineNumuber := StrToIntDef(SettingTxt.Lines.Values['BBS_LINE_NUMBER'], 0);
        BBSMessageCount := StrToIntDef(SettingTxt.Lines.Values['BBS_MESSAGE_COUNT'], 0);
        if (storedSettingTxt.Info.Count = 0) or
           (storedSettingTxt.Info[0] <> board.GetURIBase + '/SETTING.TXT') then
          NeedSETTINGTXT := True;
        if storedSettingTxt.Updated + 30 < Now then
          NeedSETTINGTXT := True;
      end else
        NeedSETTINGTXT := True;
    finally
      FreeAndNil(storedSettingTxt);
    end;
    if (board.GetBBSType = bbs2ch) and NeedSETTINGTXT then
      GetSettingTxt;

     MemoChange(nil);
  end;
end;

(* ߂ *)
procedure TWriteForm.ButtonCancelClick(Sender: TObject);
begin
  if (GetKeyState(VK_ESCAPE) < 0) and (AAList.Visible) then
  begin
    AAList.Hide;
    Memo.SetFocus
  end else
    Visible := False;
end;

(* JLR *)
procedure TWriteForm.ButtonWriteClick(Sender: TObject);
  function TagExist(const s: string):Boolean;
  begin
    if (s<>'') and (s[1]='<') and (AnsiPos('>', s)<>0) then
      Result := True
    else
      Result := False;
  end;
var
  WarningList: TStringList; 
  ActView: TViewItem; 
  Lines: Integer; 
  BoardName: string;
begin
  //݌x֌W 
  WarningList := nil; 
  try 
    WarningList := TStringList.Create; 
    if EditNameBox.Text = '' then 
    begin 
      if pos('fusianasan', SettingTxt.Lines.Values['BBS_NONAME_NAME']) > 0 then 
        WarningList.Add('̔̃ftHg̖fusianasan(IP\)łB') 
      else if SettingTxt.Lines.Values['NANASHI_CHECK'] = '1' then 
        WarningList.Add('O͂̔łB'); 
      end; 
    
      if Config.wrtDiscrepancyWarning then 
      begin 
        if formType = formWrite then 
        begin
          ActView := MainWnd.GetActiveView; 
            if Assigned(ActView) and (ActView.thread <> thread) then 
              WarningList.Add(Format('XƈႤƂu%svɏ݂܂B', [thread.title])); 
        end else 
        begin 
          if (MainWnd.currentBoard <> board) then 
             WarningList.Add(Format('XꗗƈႤƂu%svɃXĂ܂B', [board.name])); 
        end; 
      end; 
    
      if formType = formBuild then 
        if Length(EditSubjectBox.Text) <= 0 then 
          WarningList.Add('X^CłB') 
        else if Length(EditSubjectBox.Text) > StrToIntDef(SettingTxt.Lines.Values['BBS_SUBJECT_COUNT'], High(Integer)) then 
          WarningList.Add('X^CłB'); 
      if Length(EditNameBox.Text) > StrToIntDef(SettingTxt.Lines.Values['BBS_NAME_COUNT'], High(Integer)) then 
        WarningList.Add('OłB'); 
      if Length(EditMailBox.Text) > StrToIntDef(SettingTxt.Lines.Values['BBS_MAIL_COUNT'], High(Integer)) then 
        WarningList.Add('[łB'); 
    
      if Length(Memo.Text) <= 0 then 
        WarningList.Add('bZ[WłB') 
      else if (BBSMessageCount > 0) and (Length(Memo.Text) > BBSMessageCount) then 
        WarningList.Add('bZ[WłB'); 
    
      Lines := Memo.Lines.Count; 
      if (Memo.Text <> '') and (Memo.Text[Length(Memo.Text)] = #10) then 
        Inc(Lines); 
      if (BBSLineNumuber > 0) and (Lines > BBSLineNumuber * 2) then 
        WarningList.Add('słB'); 
    
      if WarningList.Count > 0 then 
      begin 
        WarningList.Add(''); 
        WarningList.Add('݂܂H'); 
        // MessageDlgƍőOʃtH[ɉBĂ܂ 
        if MessageBox(self.Handle, PChar(WarningList.Text), 'x', MB_ICONEXCLAMATION or MB_OKCANCEL) <> IDOK then 
          Exit; 
      end; 
  finally 
    WarningList.Free; 
  end; 

  if chotto then
    exit;
  if (postType = postCheck) and Memo.Modified then
    postType := postNormal;
  writeRetryCount := 0;
  cookieRetryCount := 0;
  Result.Clear;
  PostArticle;
  Memo.Modified := false;
  //VtgĂ烊Xgɒǉ
  if GetKeyState(VK_SHIFT) < 0 then
  begin
    if GetKeyState(VK_CONTROL) < 0 then
      BoardName := '<'+ board.bbs + '>' + EditNameBox.Text
    else if TagExist(EditNameBox.Text) then
      BoardName := '<*>' + EditNameBox.Text
    else
      BoardName := EditNameBox.Text;

    if Config.wrtNameList.IndexOf(BoardName) < 0 then
    begin
      Config.wrtNameList.Add(BoardName);
      SetNameBox(EditNameBox, Config.wrtNameList, board.bbs);
    end;
    if not CheckBoxSage.Checked and (Config.wrtMailList.IndexOf(EditMailBox.Text) < 0) then
    begin
      Config.wrtMailList.Add(EditMailBox.Text);
      EditMailBox.Items := Config.wrtMailList;
    end;
    Config.Modified := true;
  end;
  if formType = formWrite then
  begin
    Config.wrtRecordNameMail := RecordCheckBox.checked; //521 NameEMail̋LEŏI
    if RecordCheckBox.checked then
    begin
      thread.UsedWriteName := EditNameBox.Text;
      thread.UsedWriteMail := '!' + EditMailBox.Text;
      thread.SaveIndexData;
    end;
  end;
end;

procedure TWriteForm.OnAsyncDoneProc2(sender: TAsyncReq);
var
  res: string;
  str: string;
  str2: string;
  n: integer;
begin
  res := sender.Content;
  if length(res) <= 0 then
  begin
  end
  else
  begin
    n := AnsiPos('<iframe src=http://', res);
    if (n > 0) then
    begin
      str := Copy(res, n + 12, Length(res) - (n + 12));
      n := AnsiPos(' ', str);
      if (n > 0) then
      begin
        str := Copy(str, 1, n);
        str2 := str;
        n := AnsiPos('http://', str);
        str := Copy(str, n + 7, Length(str) - (n + 7));
        n := AnsiPos('/', str);
        str := Copy(str, 1, n - 1);
        Config.netNych := str;
      end;
    end;
  end;
  postType := postCheck;
  Result.Lines.Add('--------------------');
  Result.Lines.Add('xuށvĂEEE');
  Result.Lines.Add('--------------------');
  ButtonWrite.Enabled := true;
end;

procedure TWriteForm.PostArticle;
var
  URI: string;
  encName, encMail: string;
  postDat: string;
  URIObj: TIdURI;
  referer: string;
  list: TStringList;
  cookie: string;
  utctmp:integer; //rika
  s: string;
begin
  case board.GetBBSType of
  bbs2ch, bbsOther, bbsGetny:
    begin //rika7
      if ((board.bbs = 'morningcoffee') or (board.bbs ='ainotane')) and
      (EditNameBox.Text = '') then
        EditNameBox.Text := 'WBBB';
      utctmp := UTC;
      if Config.wrtLieTime then
        timevalue := utctmp-Config.wrtLieTimeValue*60000;
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      case formType of
      formWrite:
        begin
          case postType of
          postNormal:
            begin
              URI := 'http://' + board.host + '/test/bbs.cgi';
              postDat := 'submit=' + URLEncode('')
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&bbs='  + board.bbs
                       + '&key='  + ChangeFileExt(thread.datName, '')
                       + '&time=' + IntToStr(timeValue);
            end;
          postCheck:
            begin
              URI := 'http://' + board.host + '/test/subbbs.cgi';
              postDat := 'bbs='  + board.bbs
                       + '&key='  + ChangeFileExt(thread.datName, '')
                       + '&time=' + IntToStr(timeValue)
                       + '&subject='
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&code='  + postCode
                       + '&submit=' + URLEncode('SӔC𕉂Ƃď');
            end;
          end;
        end;
      formBuild:
        begin
          case postType of
          postNormal:
            begin
              URI := 'http://' + board.host + '/test/bbs.cgi';
              postDat := 'subject=' + URLEncode(EditSubjectBox.Text)
                       + '&submit=' + URLEncode('VKXbh쐬')
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&bbs='  + board.bbs
                       + '&time=' + IntToStr(timeValue);
            end;
          postCheck:
            begin
              URI := 'http://' + board.host + '/test/subbbs.cgi';
              postDat := 'subject=' + URLEncode(EditSubjectBox.Text)
                       + '&FROM=' + encName
                       + '&mail=' + encMail
                       + '&MESSAGE=' + URLEncode(Memo.Text)
                       + '&bbs='  + board.bbs
                       + '&time=' + IntToStr(timeValue)
                       + '&submit=' + URLEncode('SӔC𕉂Ƃď');
            end;
          end;
        end;
      end;
      postDat := postDat + ticket2ch.GetSID(URI, '&');
    end;
  bbsJBBSShitaraba:
    begin
      encName := URLEncode(sjis2euc(EditNameBox.Text));
      encMail := URLEncode(sjis2euc(EditMailBox.Text));
      URI := 'http://jbbs.shitaraba.com/bbs/write.cgi';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode(sjis2euc(''))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(sjis2euc(Memo.Text))
                   + '&DIR=' + GetJBBSShitarabaCategory(board.host)
                   + '&BBS='  + board.bbs
                   + '&KEY='  + ChangeFileExt(thread.datName, '')
                   + '&TIME=' + IntToStr(UTC);
        end;
      formBuild:
        begin
          postDat := 'SUBJECT=' + URLEncode(sjis2euc(EditSubjectBox.Text))
                   + '&submit=' + URLEncode(sjis2euc('VK'))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(sjis2euc(Memo.Text))
                   + '&DIR=' + GetJBBSShitarabaCategory(board.host)
                   + '&BBS='  + board.bbs
                   + '&TIME=' + IntToStr(UTC);
        end;
      end;
    end;
  bbsMachi, bbsJBBS:
    begin
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      URI := 'http://' + board.host + '/bbs/write.cgi';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode(sjis2euc(''))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&BBS='  + board.bbs
                   + '&KEY='  + ChangeFileExt(thread.datName, '')
                   + '&TIME=' + IntToStr(UTC);
        end;
      formBuild:
        begin
          postDat := 'SUBJECT=' + URLEncode(EditSubjectBox.Text)
                   + '&submit=' + URLEncode(sjis2euc('VK'))
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&BBS='  + board.bbs
                   + '&TIME=' + IntToStr(UTC);
        end;
      end;
    end;
  bbsWinny:
    begin
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      if (encMail = 'sage') then
      begin
        encMail := '';
      end;
      URI := 'http://' + board.host + '/';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode('')
                   + '&FROM=' + encName
                   + '&mail=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&key='  + ChangeFileExt(thread.datName, '') + #13 + #10;
        end;
      formBuild:
        begin
          URI := AnsiReplaceStr(URI, '//winny./', '//getny./cgi/CreateBbsThread2.cgi');
          postDat := 'SUBJECT=' + URLEncode(EditSubjectBox.Text)
                   + '&submit=' + URLEncode('VK')
                   + '&NAME=' + encName
                   + '&MAIL=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&BBS='  + board.bbs
                   + '&TIME=' + IntToStr(UTC);
        end;
      end;
    end;
  bbsShingetsu:
    begin
      s := '-----------------------------000000000000';
      encName := sjis2euc(EditNameBox.Text);
      encMail := sjis2euc(EditMailBox.Text);
      URI := 'http://shingetsu./POST/' + thread.datName;
      case formType of
      formWrite:
        begin
          postDat :=
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="submit"' + #$0d + #$0a +
            #$0d + #$0a +
            'POST' + #$0d + #$0a +
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="dopost"' + #$0d + #$0a +
            #$0d + #$0a +
            'dopost' + #$0d + #$0a +
            s  + #$0d + #$0a +
            'Content-Disposition: form-data; name="error"' + #$0d + #$0a +
            #$0d + #$0a +
            'error' + #$0d + #$0a +
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="name"' + #$0d + #$0a +
            #$0d + #$0a +
            encName + #$0d + #$0a +
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="mail"' + #$0d + #$0a +
            #$0d + #$0a +
            encMail + #$0d + #$0a +
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="attach"; filename=""' + #$0d + #$0a +
            'Content-Type: application/octet-stream' + #$0d + #$0a +
            #$0d + #$0a +
            #$0d + #$0a +
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="suffix"' + #$0d + #$0a +
            #$0d + #$0a +
            #$0d + #$0a +
            s + #$0d + #$0a +
            'Content-Disposition: form-data; name="message"' + #$0d + #$0a +
            #$0d + #$0a +
            sjis2euc(Memo.Text) + #$0d + #$0a +
            s + '--' + #$0d + #$0a;
        end;
      formBuild:
        begin
          URI := '';
          postDat := '';
        end;
      end;
    end;
  {bbsOther:
    begin
      encName := URLEncode(EditNameBox.Text);
      encMail := URLEncode(EditMailBox.Text);
      URI := 'http://' + board.host + '/test/bbs.cgi';
      case formType of
      formWrite:
        begin
          postDat := 'submit=' + URLEncode('')
                   + '&FROM=' + encName
                   + '&mail=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&bbs='  + board.bbs
                   + '&key='  + ChangeFileExt(thread.datName, '')
                   + '&time=' + IntToStr(UTC);
        end;
      formBuild:
        begin
          postDat := 'subject=' + URLEncode(EditSubjectBox.Text)
                   + '&submit=' + URLEncode('VKXbh쐬')
                   + '&FROM=' + encName
                   + '&mail=' + encMail
                   + '&MESSAGE=' + URLEncode(Memo.Text)
                   + '&bbs='  + board.bbs
                   + '&time=' + IntToStr(UTC);
        end;
      end;
    end;}
  end;

  URIObj := nil;
  try
    URIObj := TIdURI.Create(board.GetURIBase + '/');
    referer := URIObj.URI;
  finally
    URIObj.Free;
  end;
  cookie := 'Cookie: NAME=' + encName + '; MAIL=' + encMail;
  list := TStringList.Create;
  if (board.GetBBSType = bbs2ch) and (0 < length(Config.tstWrtCookie)) then
  begin
    {if Pos('=', Config.tstWrtCookie) < 0 then
      list.Add('Cookie: SPID=' + Config.tstWrtCookie + ';')
    else}
      cookie := cookie + '; ' + Config.tstWrtCookie;
  end;
  list.Add(cookie);
  if (Config.netWinny2Host = 'nych.info') and ((AnsiPos('//winny./', URI) > 0) or (AnsiPos('//winny.p2p/', URI) > 0)) and (Config.netNych = '') then
  begin
    s := '';
    if thread <> nil then begin
      s := ChangeFileExt(thread.datName, '');
    end;
    AsyncManager.Get('http://nych.info/' + s, OnAsyncDoneProc2);
    ButtonWrite.Enabled := false;
    Result.Lines.Add('--------------------');
    Result.Lines.Add('zXg擾EEE');
    Result.Lines.Add('--------------------');
    PageControl.Pages[3].TabVisible := true;
    PageControl.ActivePageIndex := 3;
    list.Free;
    exit;
  end;

  if (Config.netNych <> '') then
  begin
    URI := AnsiReplaceStr(URI, '//winny./', '//' + Config.netNych + '/');
    URI := AnsiReplaceStr(URI, '//winny.p2p/', '//' + Config.netNych + '/');
  end;
  procPost := Main.AsyncManager.Post(URI, postDat, referer, list,
                                     OnWritten, OnNotify);
  if procPost <> nil then
  begin
    ButtonWrite.Enabled := false;
    {beginner}
    Writing := True;
    RecentHost := board.host;
    TimeForWait := StrToIntDef(WaitList.Values[copy(board.host, 1, FindPos('.', board.host, 1) - 1)], 0) * 1000;
    WaitTimer.Enabled := True;
    WaitCount := GetTickCount;
    {/beginner}
    Result.Lines.Add('--------------------');
    Result.Lines.Add('ݒEEE');
    Result.Lines.Add('--------------------');
    TabSheetResult.TabVisible := true;
    PageControl.ActivePage := TabSheetResult;
  end;
  list.Free;
end;

procedure TWriteForm.OnNotify(sender: TAsyncReq; code: TAsyncNotifyCode);
begin
  case code of
  ancPRECONNECT:
    begin
      ticket2ch.On2chPreConnect(sender, code);
      sender.IdHTTP.AllowCookies := True;
    end;
  //ancPRETERMINATE: //rika5
  //  if procPost = sender then
  //    Windows.Sleep(1000); (* 炢҂Ă݂eXg *)
  end;
end;

procedure TWriteForm.OnWritten(sender: TAsyncReq);
var
  responseHTML: string;

  function GetErrMsg: string;
  var
    errPos, limit: integer;
  begin
    result := '';
    if responseHTML = '' then
      exit;
    limit := FindPosIC('<head>', responseHTML, 1);
    if limit >=0 then
    begin
      errPos := FindPosIC('2ch_X:', responseHTML, 1, limit);
      if errPos >= 0 then
      begin
        errPos := errPos + 6;
        limit := FindPos('-->', responseHTML, errPos, limit);
        result := trim(copy(responseHTML, errPos, limit - errPos));
      end;
    end;
  end;

  procedure SetPostCode;
  var
    codePos: integer;
  begin
    if responseHTML = '' then
      exit;
    codePos := FindPos('code value=', responseHTML, 0);
    if codePos >= 0 then
    begin
      codePos := codePos + 11;
      //Ƌcode擾
      postCode := copy(responseHTML, codePos, FindPos('>', responseHTML, codepos) - codePos);
    end;
    postType := postCheck;
    Result.Lines.Add('--------------------');
    Result.Lines.Add('mFxuށvĂEEE');
    Result.Lines.Add('--------------------');
    ButtonWrite.Enabled := true;
    {beginner}
    WaitTimer.Enabled := False;
    ButtonWrite.Caption := '(&W)';
    {/beginner}
  end;

var
  i: integer;
  viewItem: TViewItem;
  responseText: string;
  list: TStringList;
  kakikomistr: TStringList;
  errMsg: string;
  success: Boolean;
begin
  if procPost <> sender then
    exit;
  procPost := nil;
  if Config.tstCommHeaders then
  begin
    //Log('--------------------');
    //Log(postDat);
    Log('--------------------');
    Log(sender.IdHTTP.ResponseText);
    Log('--------------------');
  end;

  FtimeValue := DateTimeToUnix(Str2DateTime(sender.GetDate));
  if timeValue > FtimeValue then
    timeValue := FtimeValue;

  responseHTML := sender.GetString;
  responseText := HTML2String(responseHTML);

  Visible := true;
  PageControl.Pages[3].TabVisible := true;
  PageControl.ActivePageIndex := 3;

  if (sender.IdHTTP.ResponseCode = 200) then
  begin
    //if board.GetBBSType = bbsJBBSShitaraba then
    //  responseText := euc2sjis(responseText);

    list := TStringList.Create;
    list.Text := responseText;
    for i := 0 to list.Count -1 do
      Result.Lines.Add(list.Strings[i]);
    if (2 <= list.Count) and
       AnsiStartsStr('dqqnqI', list[0]) and
       AnsiStartsStr('ēxOCĂˁBBB', list[1]) and
       (writeRetryCount < 1) then
    begin
      list.Free;
      Inc(writeRetryCount);
      ticket2ch.Reset;
      Result.Lines.Add('--------------------');
      Result.Lines.Add('OCĎsEEE');
      Result.Lines.Add('--------------------');
      PostArticle;
      exit;
    end;

    errMsg := GetErrMsg;
    if (errMsg = 'error') then
    begin
      list.Free;
      ButtonWrite.Enabled := true;
      {beginner}
      WaitTimer.Enabled := False;
      ButtonWrite.Caption := '(&W)';
      {/beginner}
      exit;
    end;
    if ((errMsg = 'cookie') or
        ((2 <= list.Count) and AnsiContainsStr(list[0], 'NbL[mFI'))) and
       (cookieRetryCount < 1) then
    begin
      list.Free;
      Inc(cookieRetryCount);
      Config.tstWrtCookie := '';
      with sender.IdHTTP.CookieManager.CookieCollection do
      begin
        for i := 0 to Count -1 do
        begin
          //if (Items[i].CookieName = 'SPID') or (Items[i].CookieName = 'PON') then
          if (Items[i].CookieName <> 'NAME') and (Items[i].CookieName <> 'MAIL') then
          begin
            //Config.tstWrtCookie := Items[i].Value;
            //break;
            Config.tstWrtCookie := Config.tstWrtCookie + Items[i].ClientCookie + '; ';
          end;
        end;
      end;
      Config.Modified := True;
      PostArticle;
      exit;
    end;

    if (errMsg = 'check') or
       ((2 <= list.Count) and AnsiContainsStr(list[1], '݊mF')) then
    begin
      list.Free;
      SetPostCode;
      exit;
    end;

    success := false;
    if (errMsg <> '') then
    begin
      if (errMsg = 'true') or (errMsg = 'false') then
      begin
        success := true;
      end;
    end
    else
    begin
      for i := 0 to list.count - 1 do
      begin
        if (
          AnsiContainsStr(list[i], '݂܂') or
          AnsiContainsStr(list[i], '݂܂') or
          AnsiContainsStr(list[i], '܂')
        ) then
        begin
          success := true;
        end else if (board.GetBBSType = bbsShingetsu) and AnsiContainsStr(list[i], 'moved') then begin
          success := true;
        end;
      end;
    end;
    if not success then
    begin
      list.Free;
      ButtonWrite.Enabled := true;
      {beginner}
      WaitTimer.Enabled := False;
      ButtonWrite.Caption := '(&W)';
      {/beginner}
      Config.netNych := '';
      exit;
    end;
    list.Free;
  end
  else  if (sender.IdHTTP.ResponseCode = 302) then //炭Oł̐
  begin
    Result.Lines.Add('߂EEE');
    Result.Lines.Add('--------------------');
    Log('iͥjݶӥ');
  end
  else begin
    Result.Lines.Add('݂Ɏs͗l');
    Result.Lines.Add('--------------------');
    Result.Lines.Add(sender.IdHTTP.ResponseText);
    Result.Lines.Add('--------------------');
    ButtonWrite.Enabled := true;
    {beginner}
    WaitTimer.Enabled := False;
    ButtonWrite.Caption := '(&W)';
    {/beginner}
    exit;
  end;

  if thread <> nil then
  begin
    thread.LastWrote := DateTimeToUnix(Now);
    thread.SaveIndexData;

    //ݗۑ
    if Config.wrtRecordWriting then
    begin
      if not FileExists(Config.BasePath + 'kakikomi.txt') then
      try
        FileClose(FileCreate(Config.BasePath + 'kakikomi.txt'));
      except
      end;
      if kakikomiFile = nil then
      try
        kakikomiFile := TFileStream.Create(Config.BasePath + 'kakikomi.txt',
                                 fmOpenReadWrite or fmShareDenyWrite);
      except
      end;

      kakikomistr := TStringList.Create;
      try
        kakikomistr.Add('--------------------------------------------');
        kakikomistr.Add('Date   : ' + DateToStr(Date) + ' ' + TimeToStr(Time));
        kakikomistr.Add('Subject: ' + thread.title);
        kakikomistr.Add('URL    : ' + MainWnd.ThreadToURL(thread, false));
        kakikomistr.Add('FROM   : ' + EditNameBox.Text);
        kakikomistr.Add('MAIL   : ' + EditMailBox.Text);
        kakikomistr.Add('');
        kakikomistr.AddStrings(Memo.Lines);
        kakikomistr.Add('');
        kakikomistr.Add('');

        kakikomiFile.Seek(0, soFromEnd);
        kakikomiFile.Write(PChar(kakikomistr.Text)^, length(kakikomistr.Text));
      finally
        kakikomistr.Free;
      end;
    end;

    viewItem := viewList.FindViewItem(thread);
    if viewItem <> nil then
      viewItem.NewRequest(thread, gotCHECK, -1, True, Config.oprCheckNewWRedraw);
  end;

  if errMsg = 'false' then
  begin
    Caption := 'ӂoĂ܂';
    exit;
  end;

  Writing := False; //beginner
  if Config.tstCloseAfterWriting then begin
    HideOnApplicationMinimize := False;
    Visible := False;
  end;
end;

(* 悤Ɍ鎞̏ *)
procedure TWriteForm.FormHide(Sender: TObject);
begin
  //ƌ̐ݒύXɖ߂
  if chotto then
  begin
    ButtonOpen.Visible := false;
    Panel2.Visible := true;
    CheckBoxTop.Visible := true;
    RecordCheckBox.Visible := true;
//    TabSheet1.TabVisible := true;
    TabSheetPreview.TabVisible := true;
    TabSheetLocalRule.Caption := '[J[';
    {$IFNDEF IE}
    TextView.Color := RGB($ff, $ff, $ff);
    {$ENDIF}
    MainWnd.chottoURL := '';
  end;

  if not HideOnApplicationMinimize then
  begin
    SavedBoundsRect;
    if procPost = nil then
    begin
      board := nil;
      if assigned(thread) then
        thread.Release;
      thread := nil;
      chotto := false;
      Result.Clear;
    end;
    procGetSettingTxt := nil; 
    FreeAndNil(storedSettingTxt); 
    gotSettingTxt := tpsNone; 
    if MainWnd.Visible then
      MainWnd.SetFocus;
  end;
end;


(* [J[擾B *)
procedure TWriteForm.GetLocalRule;
{$IFDEF IE}
var
  URL, flag: OleVariant;
begin
  if gotRule <> tpsNone then
    exit;
  gotRule := tpsProgress;
  URL := 'about:blank';
  flag := $0E;
  WebBrowser.Navigate2(URL, flag);
  (* ̂WebBrowserDocumentCompleteĂ΂ *)
end;
{$ELSE}
begin
  if gotRule <> tpsNone then
    exit;
  TextView.Clear;
  RequestToGetLocalRule;
end;
{$ENDIF}

{$IFDEF IE}

(* JLRôŃ[J[ǂ݂ɍs *)
(* hCV[PV *)
procedure TWriteForm.WebBrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  (*  *)
  if gotRule = tpsProgress then
    RequestToGetLocalRule;
end;

{$ENDIF}

procedure TWriteForm.RequestToGetLocalRule;
var
  URI: string;
  lastModified: string;
begin
  lastModified := '';
  if storedRule = nil then
  begin
    if chotto then
      storedRule := TLocalCopy.Create('Logs\2ch\kurojane.tmp', '.idb')
    else
    storedRule := TLocalCopy.Create(board.GetLogDir + '\head.txt', '.idb');
    storedRule.Load;
    if 2 <= storedRule.Info.Count then
      lastModified := storedRule.Info.Strings[1];
  end;
  gotRule := tpsWorking;
  if chotto then
  begin
    URI := MainWnd.chottoURL;
    lastModified := '';
  end
  else
  URI := board.GetURIBase + '/head.txt';
  procGet := AsyncManager.Get(URI, OnLocalRule, ticket2ch.On2chPreConnect,
                              lastModified);
end;


(* [J[擾nh *)
procedure TWriteForm.OnLocalRule(sender: TAsyncReq);
  {$IFNDEF IE}
  procedure WriteHTML(localRule: string);
  var
    ht2v: TSimpleDat2View;
  begin
    ht2v := TSimpleDat2View.Create(TextView);
    ht2v.WriteHTML(localRule);
    ht2v.Free;
  end;
  {$ENDIF}
  function chottoReplace(const S: string):string;
  begin
    Result := S;
    Result := AnsiReplaceStr(Result,'<title>','<!--');
    Result := AnsiReplaceStr(Result,'</title>','-->');
    Result := AnsiReplaceStr(Result,'<p>','<br><br>');
    Result := AnsiReplaceStr(Result,'<dl>','<br><br>');
    Result := AnsiReplaceStr(Result,'<dt>','</dd><dt>');
    Result := AnsiReplaceStr(Result,'</dl>','</dd></dl>');
    Result := AnsiReplaceStr(Result,'</td>','<br>');
  end;

var
  localRule: string;
  {$IFDEF IE}
  URL, flag: OleVariant;
  {$ENDIF}
begin
  MainWnd.chottoURL := '';
  if procGet = sender then
  begin
    case sender.IdHTTP.ResponseCode of
    200: (* OK *)
      begin
        storedRule.Clear;
        storedRule.WriteString(sender.Content);
        storedRule.Info.Add('');
        storedRule.Info.Add(sender.GetLastModified);
        storedRule.Save;
      end;
    304: (* Not Modified *)
      begin
      end;
    else
      begin
        storedRule.Clear;
      end;
    end;
    localRule := storedRule.DataString;

    if chotto then begin
      localRule := ConvertJCode(localRule, SJIS_OUT); //184
      {$IFNDEF IE}
      localRule := chottoReplace(localRule);
      {$ENDIF}
    end;

    procGet := nil;
    {$IFDEF IE}
    (* ɗL锤 *)
    if Assigned(WebBrowser.Document) then
    begin
      OleVariant(WebBrowser.Document as IHTMLDocument2).write('<html><body>'#13#10);
      if Config.viewDefFontInfo.face <> '' then
      begin
        OleVariant(WebBrowser.Document as IHTMLDocument2)
          .write('<font face="' + Config.viewDefFontInfo.face + '">');
      end;

      OleVariant(WebBrowser.Document as IHTMLDocument2).write(localRule);
      OleVariant(WebBrowser.Document as IHTMLDocument2).write('</body></html>'#13#10);
      URL := 'JavaScript:location.reload()';
  	  flag := $0E;
  	  WebBrowser.Navigate2(URL, flag);
    end;
    {$ELSE}
    WriteHTML(localRule);
    {$ENDIF}
    storedRule.Free;
    storedRule := nil;
    gotRule := tpsDone;
  end;
end;


{$IFDEF IE}
(* [J[ʂł̃NNbN *)
procedure TWriteForm.WebBrowserBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  BeforeNavigate(URL, Cancel);
end;

procedure TWriteForm.WebBrowserStatusTextChange(Sender: TObject;
                                              const Text: WideString);
begin
  BrowserStatusTextChange(Sender, Text);
end;


{$ELSE}
procedure TWriteForm.OnBrowserMouseMove(Sender: TObject; Shift: TShiftState;
                                        X, Y: Integer);
var
  st:string;
begin
  st := TVMouseProc(THogeTextView(Sender), Shift, X, Y);
  if st <> PreViewStatus then
  begin
    PreViewStatus := st;
    BrowserStatusTextChange(Sender, PreViewStatus);
  end
  else if length(st) <= 0 then
    MainWnd.PopupHint.ReleaseHandle;
end;

procedure TWriteForm.OnBrowserMouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
var
  Cancel: WordBool;
  URL: String;
begin
  case Button of
  mbLeft:
    begin
      URL := TVMouseProc(THogeTextView(Sender), Shift, X, Y);
      if 0 < length(URL) then
      begin
        Cancel := False;
        BeforeNavigate(URL, Cancel);
      end;
    end;
  end;
end;

{$ENDIF}

 
   //SETTING.TXT擾 
   procedure TWriteForm.GetSettingTxt; 
   var 
     URI: string; 
     lastModified: string; 
   begin 
     if gotSettingTxt <> tpsNone then 
       exit; 
     lastModified := ''; 
     if storedSettingTxt = nil then 
     begin 
       storedSettingTxt := TLocalCopy.Create(board.GetLogDir + '\setting.txt', '.idb'); 
       storedSettingTxt.Load; 
       if 2 <= storedSettingTxt.Info.Count then 
         lastModified := storedSettingTxt.Info.Strings[1]; 
     end; 
     gotSettingTxt := tpsWorking; 
     URI := board.GetURIBase + '/SETTING.TXT'; 
     procGetSettingTxt := AsyncManager.Get(URI, OnSettingTxt, ticket2ch.On2chPreConnect, 
                                 lastModified); 
   end; 
    
   //SETTING.TXT擾nh 
   procedure TWriteForm.OnSettingTxt(sender: TAsyncReq); 
   var 
     lastModified: string; 
   begin 
     if procGetSettingTxt = sender then 
     begin 
       case sender.IdHTTP.ResponseCode of 
         200: (* OK *) 
           begin 
             storedSettingTxt.Clear; 
             storedSettingTxt.WriteString(StringReplace(sender.Content, #10, #13#10, [rfReplaceAll])); 
             storedSettingTxt.Info.Add(board.GetURIBase + '/SETTING.TXT'); 
             storedSettingTxt.Info.Add(sender.GetLastModified); 
             storedSettingTxt.Save; 
             SettingTxt.Text := storedSettingTxt.DataString; 
             BBSLineNumuber := StrToIntDef(SettingTxt.Lines.Values['BBS_LINE_NUMBER'], 0); 
             BBSMessageCount := StrToIntDef(SettingTxt.Lines.Values['BBS_MESSAGE_COUNT'], 0); 
             MemoChange(nil); 
           end; 
         304: (* NotModified̎ĕۑ邱ƂōŏI`FbNXV *) 
           begin 
             lastModified := ''; 
             if storedSettingTxt.Info.Count >= 2 then 
               lastModified := storedSettingTxt.Info.Strings[1]; 
             storedSettingTxt.Info.Clear; 
             storedSettingTxt.Info.Add(board.GetURIBase + '/SETTING.TXT'); 
             storedSettingTxt.Info.Add(lastModified); 
             storedSettingTxt.Save; 
           end; 
       end; 
       FreeAndNil(storedSettingTxt); 
       procGetSettingTxt := nil; 
       gotSettingTxt := tpsDone; 
     end; 
   end; 

//vr[ʂ̃|bvAbv
procedure TWriteForm.BrowserStatusTextChange(Sender:TObject; AStatusText:string);
begin
  if AStatusText<>'' then
    MainWnd.Show2chInfo(AStatusText,True)
  else
    MainWnd.PopupHint.ReleaseHandle;
end;

procedure TWriteForm.BeforeNavigate(const URL: String; var Cancel: WordBool);
var
  URI: String;
  {$IFNDEF IE}
  i: integer;
  {$ENDIF}
begin
  if URL = 'about:blank' then
    exit;
  if AnsiStartsStr('http://', URL) then
  begin
    Cancel := true;
    URI := AnsiReplaceStr(URL, 'ime.nu/', ''); //184
    MainWnd.OpenByBrowser(URI);
  end
  {$IFDEF IE}
  else if AnsiStartsStr('about:blank', URL) then
  begin
    Cancel := true;
    URI := board.GetURIBase + '/' + Copy(URL, 12, length(URL)-11);
    MainWnd.OpenByBrowser(URI);
  end;
  {$ELSE}
  {184} //ƌ̃XAJ[uEUɓn
  else if chotto then begin
    if ((URL[1] >= '0') and (URL[1] <= '9')) or (URL[1] = '-') or (URL[1] = 'l') then begin
      URI := TabSheetLocalRule.Caption;
      i := Length(URI);
      while i >= 0 do begin
        if URI[i] = '/' then begin
          Delete(URI, i + 1, Length(URI) - i);
          break;
        end;
        Dec(i);
      end;
      URI := URI + URL;
      Cancel := true;
      MainWnd.OpenByBrowser(URI);
    end;
  end
  {/184}
  else begin
    Cancel := true;
    URI := board.GetURIBase + '/' + URL;
    MainWnd.OpenByBrowser(URI);
  end;
  {$ENDIF}
end;


procedure TWriteForm.FormDestroy(Sender: TObject);
begin

  WaitList.Free; //beginner

  if storedRule <> nil then
  begin
    storedRule.Free;
    storedRule := nil;
  end;
  {$IFDEF IE}
  WebBrowser.Free;
  Preview.Free;
  {$ELSE}
  TextView.Free;
  Preview.Free;
  {$ENDIF}
  //RenXgۑ
  //if FileExists(Config.BasePath + 'name.dat') then
  //  EditNameBox.Items.SaveToFile(Config.BasePath + 'name.dat');
  if kakikomiFile <> nil then
    kakikomiFile.Free;
  //悭킩Ȃǈꉞ
  Application.UnhookMainWindow(Hook);
  LoadText.Free;
end;


//Tipsɂ܂
function TWriteForm.Hook(var Message: TMessage): Boolean;
begin
  case Message.Msg of
  CM_APPKEYDOWN:
     Result := True;  // V[gJbg𖳌ɂ
  CM_APPSYSCOMMAND:
     Result := True;  // ANZ[^𖳌ɂ
  else
     Result := False;
  end;
end;

procedure TWriteForm.MemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
  Ord('A'):
    begin
      if ssCtrl in Shift then
        Memo.SelectAll;
    end;
  end;
end;




//

//rikaproxy
procedure TWriteForm.CheckBoxUseProxyForWritingClick(Sender: TObject);
begin
  Config.netUseProxy := CheckBoxUseProxyForWriting.Checked;  //uݗpProxy̎gpvƓ
  ComboBoxProxyForWriting.Enabled := CheckBoxUseProxyForWriting.Checked;  //uݗpProxyR{{bNXv̗L̓
  if CheckBoxUseProxyForWriting.Checked then
    ComboBoxProxyForWriting.Color := clWindow
  else
    ComboBoxProxyForWriting.Color := clBtnFace;
end;

//rikaproxy
procedure TWriteForm.ComboBoxProxyForWritingChange(Sender: TObject);
var
  strlProxyServerPort: TStringList;
  strNetProxyServerForWriting :String;
  intNetProxyPortForWriting   :integer;
begin
  strlProxyServerPort := TStringList.Create;
  try
    //R{̃eLXg𕪉
    strlProxyServerPort.Delimiter := ':';
    strlProxyServerPort.DelimitedText := ComboBoxProxyForWriting.Text;
    strNetProxyServerForWriting := '';
    intNetProxyPortForWriting   := 0;
    if strlProxyServerPort.Count  > 1 then
    begin
      strNetProxyServerForWriting := strlProxyServerPort[0];
      intNetProxyPortForWriting   := StrToIntDef(strlProxyServerPort[1],0);
    end;
    //ServerPortɒlĂZbg(Ƃ肠ׂ`FbN͂Ȃ)
    if  (strNetProxyServerForWriting <> '') and (intNetProxyPortForWriting <> 0 ) then
    begin
      Config.netProxyServerForWriting := strNetProxyServerForWriting;
      Config.netProxyPortForWriting   := intNetProxyPortForWriting;
    end
    else
    begin
      //G[
      Config.netProxyServerForWriting := '';
      Config.netProxyPortForWriting   := 0;
    end;
  finally
    FreeAndNil(strlProxyServerPort);
  end;
end;

(* AA͎x͖{Ƃɕt̂ŃRgAEg
procedure TWriteForm.ButtonAAClick(Sender: TObject);
begin
  if chotto then
    exit;
  ListBoxOneLineAA.Visible := true;
  ListBoxOneLineAA.SetFocus;
end;

//rikaAA
procedure TWriteForm.ListBoxOneLineAAKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  iniAAs:TMemIniFile; //rikaAA
  strLinesAA,strAAs: TStringList;
  i: integer;
  AAs : string;
begin
  case Key of
  VK_RETURN:
    begin
      if ListBoxOneLineAA.ItemIndex = -1 then
        ListBoxOneLineAA.ItemIndex := 0;
      strLinesAA := TStringList.Create;
      strAAs     := TStringList.Create;
      try
        strLinesAA.Delimiter := '*';
        strLinesAA.DelimitedText := ListBoxOneLineAA.Items[ListBoxOneLineAA.ItemIndex];
        if (strLinesAA.Count > 1) and (strLinesAA[0]='') then
        begin
          if FileExists(IncludeTrailingPathDelimiter(Config.BasePath) + 'aalist.txt') then
          begin
            iniAAs := TMemIniFile.Create(IncludeTrailingPathDelimiter(Config.BasePath) + 'aalist.txt');
            try
              iniAAs.ReadSectionValues(strLinesAA[1],strAAs);
              for i:=0 to strAAs.Count-1 do
                AAs := AAs+strAAs[i]+ #13#10;
              Memo.SelText := AAs;
            finally
              FreeAndNil(iniAAs);
            end;
          end;
        end
        else
          Memo.SelText := ListBoxOneLineAA.Items[ListBoxOneLineAA.ItemIndex];

        ListBoxOneLineAA.Visible := false;
        Memo.SetFocus;
      finally
        FreeAndNil(strLinesAA);
        FreeAndNil(strAAs);
      end;
    end;
  end;
end;

//ƓŁB
procedure TWriteForm.ListBoxOneLineAAMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  iniAAs:TMemIniFile; //rikaAA
  strLinesAA,strAAs: TStringList;
  i: integer;
  AAs : string;
begin
  strLinesAA := TStringList.Create;
  strAAs     := TStringList.Create;
  try
    strLinesAA.Delimiter := '*';
    strLinesAA.DelimitedText := ListBoxOneLineAA.Items[ListBoxOneLineAA.ItemIndex];
    if (strLinesAA.Count > 1) and (strLinesAA[0]='') then
    begin
      if FileExists(IncludeTrailingPathDelimiter(Config.BasePath) + 'aalist.txt') then
      begin
        iniAAs := TMemIniFile.Create(IncludeTrailingPathDelimiter(Config.BasePath) + 'aalist.txt');
        try
          iniAAs.ReadSectionValues(strLinesAA[1],strAAs);
          for i:=0 to strAAs.Count-1 do
            AAs := AAs+strAAs[i]+ #13#10;
          Memo.SelText := AAs;
        finally
          FreeAndNil(iniAAs);
        end;
      end;
    end
    else
      Memo.SelText := ListBoxOneLineAA.Items[ListBoxOneLineAA.ItemIndex];

    ListBoxOneLineAA.Visible := false;
    Memo.SetFocus;
  finally
    FreeAndNil(strLinesAA);
    FreeAndNil(strAAs);
  end;
end;

procedure TWriteForm.ListBoxOneLineAAExit(Sender: TObject);
begin
  ListBoxOneLineAA.Visible := false;
end;*)

procedure TWriteForm.ButtonOpenClick(Sender: TObject);
begin
  if not MainWnd.NavigateIntoView(TabSheetLocalRule.Caption, gtOther) then
    MainWnd.OpenByBrowser(TabSheetLocalRule.Caption);
  ButtonCancelClick(Self);
end;

{------------------------------------------------------------------------}
{------------------------------------------------------------------------}

//{$LINK crypt3}
(* vr[{Ƃɕt̂ŃRgAEg
function _crypt(key, salt: PChar): PChar; cdecl; external;

{----------------------------------
$salt = substr($key."H.", 1, 2);
$salt =~ s/[^\.-z]/\./go;
$salt =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/;
-----------------------------------}
function MakeSalt(const Key: string): string;
var
  i: Integer;
begin
  Result := Copy(Key + 'H.', 2, 2);

  for i:=1 to Length(Result) do
  begin
    if ( Ord(Result[i]) < Ord('.') ) or ( Ord('z') < Ord(Result[i]) ) then
      Result[i] := '.';

    if ((Ord(':') <= Ord(Result[i])) and (Ord(Result[i]) <= Ord('@'))) then
      Result[i] := Char(Ord(Result[i]) - Ord(':') + Ord('A'))
    else if ((Ord('[') <= Ord(Result[i])) and (Ord(Result[i]) <= Ord('`'))) then
      Result[i] := Char(Ord(Result[i]) - Ord('[') + Ord('a'));
  end;
end;

function Trip(const Key: string): string;
var
  Salt: string;
begin
  Salt := MakeSalt(Key);
  Result := '' + Copy(_crypt(PChar(Key), PChar(Salt)), 4, 10);
end;

{------------------------------------------------------------------------}


function TWriteForm.Res2Dat: string;
  function HtmlPost(const S: string):string;
  begin
    Result := S;
    Result := AnsiReplaceStr(Result, '<', '&lt;');
    Result := AnsiReplaceStr(Result, '>', '&gt;');
    Result := AnsiReplaceStr(Result, #13#10, '<br>');
    Result := AnsiReplaceStr(Result, #13, '<br>');
    Result := AnsiReplaceStr(Result, #10, '<br>');
  end;
  function NameConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    Result := AnsiReplaceStr(Result, '', '');
    Result := AnsiReplaceStr(Result, '', '');
    if AnsiPos('#', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('#', Result) - 1) + '</b>'
        + Trip(Copy(Result,AnsiPos('#', Result) + 1, Length(Result))) + ' <b>';
    end;
    if AnsiPos('', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('', Result) - 1) + '</b>'
        + Trip(Copy(Result,AnsiPos('', Result) + 2, Length(Result))) + ' <b>';
    end;
    if not Config.tstAuthorizedAccess then
    begin
      Result := AnsiReplaceStr(Result, '', '');
    end;
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
  function MailConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    if AnsiPos('#', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('#', Result) - 1);
    end;
    if AnsiPos('', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('', Result) - 1);
    end;
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
  function MessageConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
var
  aName, aMail, aDate, aMessage: string;
begin
  aName := EditNameBox.Text;
  aMail := EditMailBox.Text;
  aDate := FormatDateTime('yy/mm/dd hh:nn', Now);
  aMessage := Memo.Text;

  aName := NameConv(aName);
  aMail := MailConv(aMail);
  aMessage := MessageConv(aMessage);

  if Length(aName) = 0 then
    aName := '</b><b>';

  Result := aName + '<>'
          + aMail + '<>'
          + aDate + '<>'
          + aMessage + '<>' + #10;
end;*)

//܂


{------------------------------------------------------------------------}
{------------------------------------------------------------------------}

class function TWriteForm.Trip(const Key: string): string;
{----------------------------------
$salt = substr($key."H.", 1, 2);//<--ǂ
$salt =~ s/[^\.-z]/\./go;
$salt =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/;
-----------------------------------}
  function MakeSalt(const Key: string): string;
  var
    i: Integer;
  begin
    Result := Copy(Copy(Key, 2, 2) + 'H.', 1, 2);

    for i:=1 to Length(Result) do
    begin
      if ( Ord(Result[i]) < Ord('.') ) or ( Ord('z') < Ord(Result[i]) ) then
        Result[i] := '.';

      if ((Ord(':') <= Ord(Result[i])) and (Ord(Result[i]) <= Ord('@'))) then
        Result[i] := Char(Ord(Result[i]) - Ord(':') + Ord('A'))
      else if ((Ord('[') <= Ord(Result[i])) and (Ord(Result[i]) <= Ord('`'))) then
        Result[i] := Char(Ord(Result[i]) - Ord('[') + Ord('a'));
    end;
  end;
var
  Salt: string;
begin
  if Key = '' then
  begin
    Result := '#';
  end else
  begin
    Salt := MakeSalt(Key);
    Result := ' ' + Copy(crypt(Key, Salt), 4, 10);
  end;
end;

{------------------------------------------------------------------------}


function TWriteForm.Res2Dat: string;
  function HtmlPost(const S: string):string;
  begin
    Result := S;
    Result := AnsiReplaceStr(Result, '<', '&lt;');
    Result := AnsiReplaceStr(Result, '>', '&gt;');
    Result := AnsiReplaceStr(Result, #13#10, '<br>');
    Result := AnsiReplaceStr(Result, #13, '<br>');
    Result := AnsiReplaceStr(Result, #10, '<br>');
  end;
  function NameConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    Result := AnsiReplaceStr(Result, '', '');
    Result := AnsiReplaceStr(Result, '', '');
    if AnsiPos('#', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('#', Result) - 1) + '</b>'
        + Trip(Copy(Result,AnsiPos('#', Result) + 1, Length(Result))) + ' <b>';
    end;
    if AnsiPos('', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('', Result) - 1) + '</b>'
        + Trip(Copy(Result,AnsiPos('', Result) + 2, Length(Result))) + ' <b>';
    end;
    if not Config.tstAuthorizedAccess then
    begin
      Result := AnsiReplaceStr(Result, '', '');
    end;
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
  function MailConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    if AnsiPos('#', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('#', Result) - 1);
    end;
    if AnsiPos('', Result) > 0 then
    begin
      Result := Copy(Result, 1, AnsiPos('', Result) - 1);
    end;
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
  function MessageConv(const S: string):string;
  begin
    Result := HtmlPost(S);
    Result := AnsiReplaceStr(Result, '"', '&quot;');
  end;
var
  aName, aMail, aDate, aMessage: string;
  p1, p2: PChar;
  tmp: String; //beginner
begin
  if EditNameBox.Text <> '' then
    begin
      if board.GetBBSType = bbs2ch then
        aName := StringReplace(EditNameBox.Text, '&r', '', [rfReplaceAll])
      else
        aName := EditNameBox.Text;
    end else
      aName := SettingTxt.Lines.Values['BBS_NONAME_NAME'];
    
  aMail := EditMailBox.Text;
  aDate := FormatDateTime('yy/mm/dd hh:nn', Now);
  if SameText(SettingTxt.Lines.Values['BBS_FORCE_ID'], 'checked') then
    aDate := aDate + ' ID:xxxxxxxxxx'
  else if (SettingTxt.Lines.Values['BBS_NO_ID'] = '') or
          SameText(SettingTxt.Lines.Values['ID_DISP'], 'show') then
    if Length(aMail) = 0 then
      aDate := aDate + ' ID:xxxxxxxxxx'
    else
      aDate := aDate + ' ID:???';

  aMessage := Memo.Text;

  aName := NameConv(aName);
  aMail := MailConv(aMail);
  aMessage := MessageConv(aMessage);

  if Length(aName) = 0 then
    aName := '<b></b>';
    
  Result := aName + '<>'
          + aMail + '<>'
          + aDate + '<>'
          + aMessage + '<>' + #10;

   
     //Unicodeu̏ 
     if SameText(SettingTxt.Lines.Values['BBS_UNICODE'], 'change') then 
     begin 
       p1 := PChar(Result); 
       SetLength(tmp, Length(Result)); 
       p2 := PChar(tmp); 
       while True do 
       begin 
         if (p1^ = '&') and ((p1 + 1)^ ='#') then 
         begin 
           p2^ := #$81; 
           inc(p2); 
           p2^ := #$48; 
           inc(p2); 
           inc(p1, 2); 
           while p1^ in ['0'..'9'] do 
             inc(p1); 
           if p1^ = ';' then 
             inc(p1); 
         end else 
         begin 
           if p1^ in LeadBytes then 
           begin 
             p2^ := p1^; 
             inc(p1); 
             inc(p2); 
             p2^ := p1^; 
             inc(p1); 
             inc(p2); 
           end else 
           begin 
             p2^ := p1^; 
             if p1^ = #10 then 
               Break; 
             inc(p1); 
             inc(p2); 
           end; 
         end; 
       end; 
       Result := copy(tmp, 1, p2 - PChar(tmp) + 1); 
     end; 
end;

function ZoomToPoint(zoom: integer): Integer;
begin
  result := -12; // 9;
  {case zoom of
  0: result := -9;
  1: result := -10;
  2: result := -12;
  3: result := -14;//521 -16
  4: result := -15;//521 -24
  end;}
end;

function ZoomToExternalLeading(zoom: integer): Integer;
begin
  result := 1;
  case zoom of
  0: result := 1;
  1: result := 2;
  2: result := 2;
  3: result := 3;
  4: result := 4;
  end;
end;

{$IFDEF IE}
procedure TWriteForm.PreviewBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
begin
  if URL = 'about:blank' then
    WritePreview;
end;

procedure TWriteForm.PreviewBrowserBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  if URL <> 'about:blank' then
    Cancel := True;
end;
{$ENDIF}

procedure TWriteForm.MakePreview;
{$IFDEF IE}
var
  URL: OleVariant;
  flag: OleVariant;
begin
  URL := 'about:blank';
  flag := $0E;
  Preview.Navigate2(URL, flag);
end;
{$ELSE}
begin
  Preview.Clear;
  WritePreview;
end;
{$ENDIF}

procedure TWriteForm.WritePreview;
  function MakeDummyDat(line: Integer):string;
  const
//  dummyDat : string = '<>sage<>01/01/01 00:00<>message<>'#10;
    dummyDat : string = '<><><><>'#10;
  begin
    Result := DupeString(dummyDat, line);
  end;
const
  {$IFDEF IE}
  HeaderSkin = '<html><body bgcolor=#efefef LINK="blue" VLINK="blue" ALINK="blue" ><font face="lr oSVbN"><dl>';
  {$ELSE}
  HeaderSkin = '<html><body><font face="lr oSVbN"><dl>';
  {$ENDIF}
var
  dat: TThreadData;
  ResSkin: string;
  {$IFDEF IE}
  TempStream: TWebOutBufferStreamForExtraction;
  size, res: OleVariant;
  {$ELSE}
  TempStream: TDat2ViewForExtraction;
  {$ENDIF}
  PreviewD2HTML: TDat2HTML;
begin
  {$IFDEF IE}
  TempStream := TWebOutBufferStreamForExtraction.Create(Preview);
  if EditMailBox.Text='' then
    ResSkin := '<dt><PLAINNUMBER/> F<font color=forestgreen><NAME/></b></font>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10
  else
    ResSkin := '<dt><PLAINNUMBER/> F<font color=blue><u><NAME/></u></b></font>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10;
  {$ELSE}
  TempStream := TDat2ViewForExtraction.Create(Preview);
  if EditMailBox.Text='' then
    ResSkin := '<dt><PLAINNUMBER/> F<SA i=2><b><NAME/></b></b><SA i=0>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10
  else
    ResSkin := '<dt><PLAINNUMBER/> F<SA i=1><b><NAME/></b></b><SA i=0>[<MAIL/>] F<DATE/></dt><dd><MESSAGE/><br><br></dd>'#10;
  {$ENDIF}
  if assigned(thread) then begin
    TempStream.Base:=MainWnd.ThreadToURL(thread);
    TempStream.BBSType:=TBoard(thread.board).GetBBSType;
  end;
  PreviewD2HTML := TDat2HTML.Create(resSkin);
  dat := TThreadData.Create;
  try
    {$IFDEF IE}
    if Preview.Document = nil then
      exit;
    size := 2; // 5;
    try
      Preview.ExecWB(OLECMDID_ZOOM , OLECMDEXECOPT_DONTPROMPTUSER, size, res);
    except
    end;
    {$ELSE}
    Preview.ExternalLeading := ZoomToExternalLeading(Config.viewZoomSize);
    Preview.SetFont(Preview.Font.Name, ZoomToPoint(Config.viewZoomSize));
    {$ENDIF}
    TempStream.WriteHTML(HeaderSkin);
    TempStream.Flush;
    if Assigned(thread) then
    begin
      dat.Add(MakeDummyDat(thread.lines));
      dat.Add(Res2Dat);
      PreviewD2HTML.ToDatOut(TempStream, dat, thread.lines + 1, 1)
    end else
    begin
      dat.Add(Res2Dat);
      PreviewD2HTML.ToDatOut(TempStream, dat, 1, 1);
    end;
    //{$IFNDEF IE}
    //Preview.Invalidate;
    //{$ENDIF}
    TempStream.Flush;
  finally
    dat.Free;
    PreviewD2HTML.Free;
    TempStream.Free;
  end;
end;

procedure TWriteForm.writeActFocusThreadExecute(Sender: TObject);
begin
  MainWnd.MenuWndThreadClick(Self);
end;

//ۑp̈ʒuԂ(kłƂ͌̃TCYԂ)
function TWriteForm.SavedBoundsRect:TRect;
begin
  Result:=BoundsRect;
  if WindowState <> wsMaximized then
  begin
    if 0 < savedWidth then
      Result.Right := Result.Left + savedWidth;
    if 0 < savedHeight then
      Result.Bottom := Result.Top + savedHeight;
  end;
  Config.wrtFormTop := Result.Top;
  Config.wrtFormLeft := Result.Left;
  Config.wrtFormHeight := Result.Bottom - Result.Top;
  Config.wrtFormWidth := Result.Right - Result.Left;
end;

//AvŏɎB(Main.pasTMainWnd.OnAboutToShowQ)
procedure TWriteForm.MainWndOnHide;
begin
  if Visible and (not Config.wrtFmUseTaskBar) then
  begin
    HideOnApplicationMinimize:=True;
    Hide;
  end;
end;

//AvɕKvȂ畜(Main.pasTMainWnd.OnAboutToShowQ)
procedure TWriteForm.MainWndOnShow;
begin
  if HideOnApplicationMinimize and (not Config.wrtFmUseTaskBar) then
    Self.Show;
  HideOnApplicationMinimize := False;
end;

(* AA͎x *)
procedure TWriteForm.AAListMouseUp(Sender: TObject; Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    if  (AAList.ItemIndex > -1) then
    begin
      PasteAAListItem;
    end;
    AAList.Hide;
    Memo.SetFocus;
  end;
end;

procedure TWriteForm.writeActShowAAListExecute(Sender: TObject);
var
  point: TPoint;
begin
  if 0 < AAList.Count then
  begin
    GetCaretPos(point);
    AAList.Top  := PageControl.Top + TabSheetMain.Top  + Memo.Top + point.Y;
    if Memo.Height < point.Y + AAList.Height + 30 then
      AAList.Top := AAlist.Top - point.Y + Memo.Height - AAList.Height - 30;
    AAList.Left := PageControl.Left+ TabSheetMain.Left + Memo.Left + point.X;
    if Memo.Width < point.X + AAList.Width + 30 then
      AAList.Left := AAlist.Left - point.X + Memo.Width - AAList.Width - 30;
    AAList.ItemIndex := 0;
    AAList.Show;
    AAList.SetFocus;
  end;
end;

procedure TWriteForm.AAListKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then
  begin
    AAList.Hide;
    Memo.SetFocus;
  end else
  if (Key = VK_RETURN) then
  begin
    if (AAList.ItemIndex > -2) then
    begin
      PasteAAListItem;
    end;
    AAList.Hide;
    Memo.SetFocus;
  end;
end;

procedure TWriteForm.AAListExit(Sender: TObject);
begin
  AAList.Hide;
end;

procedure TWriteForm.PasteAAListItem;
var
  text: string;
  index: integer;
begin
  text := AAList.Items[AAList.ItemIndex];
  if StartWith('*', text, 1) then
  begin
    index := 0;
    while (CompareStr('['+ Copy(text, 2, Length(text) - 1) + ']', LoadText[index]) <> 0) do
    begin
      Inc(index);
      if LoadText.Count - 1 <= index then
        exit;
    end;
    Inc(index);
    while not (StartWith('[', LoadText[index], 1)) do
    begin
      Memo.SelText := LoadText[index] + #13#10;
      if index < LoadText.Count - 1 then
        Inc(index)
      else
        break;
    end;
  end else
    Memo.SelText := text;
end;


{beginner}
//procedure TWriteForm.MemoChange(Sender: TObject);
//begin
//  EditLineNumber.Text := IntToStr(Memo.Lines.Count);
//end;
{/beginner}


{beginner}
procedure TWriteForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  MainWnd.PopupHint.ReleaseHandle;
end;
{/beginner}

{beginner}
procedure TWriteForm.WaitTimerTimer(Sender: TObject);
var
  NowAt: Cardinal;
  Reminder: Integer;
begin
  if not ButtonWrite.Enabled then begin
    NowAt := GetTickCount;
    if NowAt < WaitCount then
      Reminder := Integer(TimeForWait - (NowAt + (high(Cardinal) - WaitCount) + 1)) div 1000
    else
      Reminder := Integer(TimeForWait - (NowAt - WaitCount)) div 1000;

    if Reminder <= 0 then begin
      if Not Writing then begin
        ButtonWrite.Caption := '(&W)';
        ButtonWrite.Enabled := True;
      end;
      WaitTimer.Enabled := False;
    end else begin
      ButtonWrite.Caption := IntToStr(Reminder);
    end;
  end;
end;
{/beginner}

//݃bZ[W̕AsJEg 
   procedure TWriteForm.MemoChange(Sender: TObject); 
   var 
     tmpTxt: String; 
     tmpColor: TColor; 
     Lines: Integer; 
   begin 
     Lines := Memo.Lines.Count; 
     if (Memo.Text <> '') and (Memo.Text[Length(Memo.Text)] = #10) then 
       Inc(Lines); 
    
     tmpColor := Self.Color; 
     if BBSLineNumuber > 0 then 
       if Lines > BBSLineNumuber * 2 then 
         tmpColor := $007f7fff 
       else if Lines > BBSLineNumuber then 
         tmpColor := $007fffff; 
     PanelColor[1] := tmpColor; 
    
     tmpTxt := Format('%4d',[Lines]); 
     if BBSLineNumuber > 0 then 
       WStatusBar.Panels[1].Text := Format('Lines: %4d/%4d',[Lines, BBSLineNumuber * 2]) 
     else 
       WStatusBar.Panels[1].Text := Format('Lines: %4d/ s',[Lines]); 
    
     if (BBSMessageCount > 0) and (Length(Memo.Text) > BBSMessageCount) then 
       PanelColor[0] := $007f7fff 
     else 
       PanelColor[0] := clBtnFace; 
    
     tmpTxt := Format('%4d',[Length(Memo.Text)]); 
     if BBSMessageCount > 0 then 
       WStatusBar.Panels[0].Text := Format('Bytes: %6d/%6d',[Length(Memo.Text), BBSMessageCount]) 
     else 
       WStatusBar.Panels[0].Text := Format('Bytes: %6d/  s',[Length(Memo.Text)]); 
   end; 
    
   procedure TWriteForm.WStatusBarDrawPanel(StatusBar: TStatusBar; 
     Panel: TStatusPanel; const Rect: TRect); 
     function RealHeight(Font: TFont): Integer; 
     var 
       tm: TEXTMETRIC; 
     begin 
       if Font.Height >= 0 then 
         result := Abs(Font.Height) 
       else 
       begin 
         GetTextMetrics(StatusBar.Canvas.Handle, tm); 
         result := Abs(Font.Height) + tm.tmInternalLeading; 
       end; 
     end; 
   var 
     i: Integer; 
     X, Y: Integer; 
   begin 
     StatusBar.Canvas.Brush.Color := WStatusBar.Color; 
     for i := Low(PanelColor) to High(PanelColor) do 
     begin 
       if Panel = StatusBar.Panels[i] then 
       begin 
         StatusBar.Canvas.Brush.Color := PanelColor[i]; 
         Break; 
       end; 
     end; 
     X := Rect.Left + 4; 
     Y := (Rect.Top + Rect.Bottom - RealHeight(StatusBar.Canvas.Font)) div 2 + 1; 
     StatusBar.Canvas.TextRect(Rect, X, Y, Panel.Text); 
 end;

end.
