// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997,1998,1999,2000
//
// ARJ32֘AW[	ARJ32.PAS
//
// v1.00:Jo[W
// v1.01:Open/Close \bh FindOpen/FindClose ɉ
// v1.02:uses ߂sgpjbg Forms O
//		 t@CXgp[^̌^ TStrings ɕύX
//		 ^Cg̃Rg኱ύX
// v1.03:Delphi 3 ɑΉ
// v1.05:ɓACe폜p\bhǉ
//		 LoadDll/FreeDll ̍\ύX
//		 Ƀt@C@\ǉ
// v1.06:ɑ상\bh̖߂lss̑΍
// v1.09:Update/ExtractTo \bh PackTo/UnpackTo ɉ
// v1.11:eNX̃\bh錾̌
//		 svϐ̐錾폜
// v1.12:TArchiveFile  Output/OutputSize vpeBǉ
//		 \bh̎኱ύX
// v1.17:LoadDll/FreeDll/IsXXXArchive ̍\ύX
// v1.20:̃NXłPackTo/MakeSfx \bh𒆎~
// v1.21:LoadDll/FreeDll ̉xύX
// v1.22:o߃CxgT|[gǉ
// v1.23:CheckArchive \bhǉ
//       ȃ\bh̉
// v1.24:UNARJ32J.DLL Ȃ̃bZ[WC
// v1.25:ZIP32J.DLLł̖O"["܂ރt@Cւ̑Ή
// v1.28:WJ@\̃T|[gǉ
//	      CheckArchive \bh̖߂ľ^ύX
// v1.30:e\bh FileList ̌^ύX
// v1.32:IsSetOwnerWinow/KillOwnerWindow ̎ύX
//       UnArj ֐ɃEBhEnhnĂȂ̂C
// v1.35:TArj32.Arj  CmdLine ĂȂs̏C
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.42:[hDLLԈĂ̂C
// v1.48:gy nIvṼRgǉ
//
unit ARJ32;

interface

uses Windows,SysUtils,Classes,Archives,Lha32;

type
	TArj32 = class( TLha32 )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
//		function  BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:TStringList ):String; override;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo				   ):integer; override;
		function  FindClose( hArc:THArc													   ):integer; override;

	public
		function Arj( Handle:HWND;CmdLine:string;var Output:string ):integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function RemoveItem   ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function MakeSfxFile  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                     ;var Output:string ):Integer; override;
//		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD   ):Integer; override;
		function CheckArchive ( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;

		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND							 ):boolean; override;
	end;

	function IsArjArchive( ArchiveFileName:string ):boolean;
//	function Arj( _hwnd:HWND;_szCmdLine:PAnsiChar;_szOutput:PAnsiChar;_wSize:integer ):integer; stdcall;

implementation

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDLL;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TArchiverDll.Create( 'ARJ `','UNARJ32J.DLL','Unarj' );
	FArchiver.LoadDLL;
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
class procedure TArj32.LoadDll;
begin
	Arj32.LoadDll;
end;

class procedure TArj32.FreeDll;
begin
	Arj32.FreeDll;
end;

function TArj32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'x',ArchiveFileName,Options,DstPath,FileList,UseResFile );
	result := Arj( Handle,FCmdLine,Output );
end;

function TArj32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

function TArj32.SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	inherited SetOwnerWindowEx( Handle,lpArcProc );
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
end;

function TArj32.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

function TArj32.Arj( Handle:HWND;CmdLine:string;var Output:string ):integer;
begin
	result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TArj32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result:= FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TArj32.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TArj32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TArj32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

//	function IsArjArchive( ArchiveFileName:string ):boolean;
//	var
//		SfxType:	integer;
//	begin
//		try
//			LoadDll;
//			SfxType:= FArchiver.CheckArchive( PChar( ExpandFileName( ArchiveFileName )),CHECKARCHIVE_SFX+CHECKARCHIVE_ALL );
//			result := ( SfxType <> -1 );
//		except
//			result := false;
//		end;
//	end;

function IsArjArchive( ArchiveFileName:string ):boolean;
var
	hArc:		THARC;
begin
	try
		LoadDLL;
		hArc := FArchiver.OpenArchive( 0,PAnsiChar( ExpandFileName( ArchiveFileName )),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
		FArchiver.CloseArchive( hArc );
		result := ( hArc <> 0 );
	except
		result := false;
	end;
end;

end.
